Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.api
Class CatalogAPI

    java.lang.Object
      jet.api.API
          jet.api.CatalogAPI

Direct Known Subclasses:
  MultipliedCatalogAPI, MultiUserCatalogAPI

    public class CatalogAPI

extends API

The CatalogAPI class allows an application to create and manipulate JReport catalog objects. By building a CatalogAPI instance in a Java program, users can edit a catalog by methods provided by API.

JReport catalog and its objects are stored in a tree structure. An instance of `CatalogAPI` can retrieve each object in the catalog by its handle. The handle of the catalog object is named by its qualified and unique instance name. Besides the handle, some catalog objects also have resource names, such as query, table, table column, and formula. And the resource name of table, field(formula,parameter) also be called mapping name. The mapping name maps the real name of a database object to JReport catalog's name.

The following are the objects that a JReport catalog can hold:

- Data sources, including connection of JDBC, ODBC, XML, Web Services, and Hierarchical
- Tables, views and stored procedures
- Imported queries (SQL files) and queries
- User data sources (UDS) and hierarchical data sources (HDS)
- Business/Report cubes (BusinessLogic)
- Business views
- Parameters
- Formulas and summaries

A `CatalogAPI` instance can be generated by a `Designer` instance. Below is an example of the use of the `CatalogAPI`.

>       Designer dr = null;
>       try
>       {
>             String path = %install root%/JReport/demo/reports/SampleReports/;
>             String catName = "SampleReports.cat";
>             DesignerUserInfo userInfo=new DesignerUserInfo("UID", "license key");
>             dr = new Designer(path, catName,userInfo);
>             CatalogAPI cat = dr.getCatalogAPI();
>       }
>       catch(Exception e)
>       {
>             ;
>       }
>       finally
>       {
>             dr.exit();
>       }

Field Summary
`static int` | `ALIAS` SQL alias class type.
`static int` | `AVERAGE` constant for summary function name
`static java.lang.String` | `BINARY` Deprecated.
`static java.lang.String` | `BOOLEAN` parameter data type
`static int` | `BUSINESSLOGIC` BusinessLogic (also named Business/Report Cube) object type.
`static int` | `BUSINESSLOGIC_CATEGORY` BusinessLogic (also named Business/Report Cube) Category object type.
`static int` | `BUSINESSLOGIC_DETAILINFO` BusinessLogic (also named Business/Report Cube) Detail object type.
`static int` | `BUSINESSLOGIC_DIMENSION` BusinessLogic (also named Business/Report Cube) Dimension object type.
`static int` | `BUSINESSLOGIC_HIERARCHY` BusinessLogic (also named Business/Report Cube) Hierarchy object type.
`static int` | `BUSINESSLOGIC_HIERARCHYCONTAINER` BusinessLogic (also named Business/Report Cube) Hierarchy container object type.
`static int` | `BUSINESSLOGIC_MEASURE` BusinessLogic (also named Business/Report Cube) Measure object type.
`static int` | `BUSINESSVIEW` BusinessView object type.
`static int` | `BUSINESSVIEW_AGGREGATION` BusinessView AGGREGATION object type.
`static int` | `BUSINESSVIEW_DETAIL` BusinessView DETAIL object type.
`static int` | `BUSINESSVIEW_GROUP` BusinessView Group object type.
`static int` | `CATALOG` Catalog object type.
`static int` | `COLUMN` Column object type.
`static int` | `CONNECTION` Connection object type.
`static int` | `COUNT` constant for summary function name
`static java.lang.String` | `CURRENCY` parameter data type
`static int` | `DATABASE` Database object type.
`static java.lang.String` | `DATE` parameter data type
`static java.lang.String` | `DATETIME` parameter data type
`static java.lang.String` | `DECIMAL` Deprecated.
`static int` | `DISTINCTCOUNT` constant for summary function name
`static int` | `ENCODINGAUTO` encoded data type
`static int` | `ENCODINGNO` encoded data type
`static int` | `ENCODINGYES` encoded data type
`static int` | `EXTRA_NAME_JDBC` extra name type
`static int` | `EXTRA_NAME_USERDEFINED` extra name type
`static int` | `FILESQL` Imported SQL object type.
`static int` | `FORMULA` Formula object type.
`static int` | `HDS` HierDataSource object type.
`static java.lang.String` | `INTEGER` parameter data type
`static int` | `JDBC` Connection with JDBC
`static int` | `JDBC_ODBC_BRIDGE` Connection with JDBC-ODBC bridge
`static int` | `MAXIMUM` constant for summary function name
`static int` | `MINIMUM` constant for summary function name
`static java.lang.String` | `NUMBER` parameter data type
`static int` | `ONDEMAND_QUERY` Demand Query object type.
`static int` | `PARAMETER` Parameter object type.
`static java.lang.String` | `PARAMETERS` parameter data type
`static int` | `PATTERN_1PART_NAME` qualified name pattern
`static int` | `PATTERN_2PART_NAME` qualified name pattern
`static int` | `PATTERN_3PART_NAME` qualified name pattern
`static int` | `POPULATIONSTDDEV` constant for summary function name
`static int` | `POPULATIONVARIANCE` constant for summary function name
`static int` | `PROCEDURE` Stored Procedure object type.
`static int` | `QUERY` Query object type
`static int` | `READ_ONLY_DEFAULT` connection Read-only property
`static int` | `READ_ONLY_FALSE` connection Read-only property
`static int` | `READ_ONLY_TRUE` connection Read-only property
`static int` | `RUNNING_AVERAGE` constant for summary function name
`static int` | `RUNNING_COUNT` constant for summary function name
`static int` | `RUNNING_DISTINCTCOUNT` constant for summary function name
`static int` | `RUNNING_MAXIMUM` constant for summary function name
`static int` | `RUNNING_MINIMUM` constant for summary function name
`static int` | `RUNNING_SUM` constant for summary function name
`static int` | `STDDEV` constant for summary function name
`static java.lang.String` | `STRING` parameter data type
`static int` | `SUM` constant for summary function name
`static int` | `SUMMARY` Summary object type.
`static int` | `SYNONYM` SQL synonym class type.
`static int` | `TABLE` Table object type.
`static java.lang.String` | `TIME` parameter data type
`static int` | `TRANSACTION_DEFAULT` transaction isolation level value
`static int` | `TRANSACTION_NONE` transaction isolation level value
`static int` | `TRANSACTION_READ_COMMITTED` transaction isolation level value
`static int` | `TRANSACTION_READ_UNCOMMITTED` transaction isolation level value
`static int` | `TRANSACTION_REPEATABLE_READ` transaction isolation level value
`static int` | `TRANSACTION_SERIALIZABLE` transaction isolation level value
`static int` | `UDS` User Defined DataSource object type.
`static int` | `UNIFIEDBUSINESSVIEW` Unified BusinessView object type.
`static int` | `VARIANCE` constant for summary function name
`static int` | `VIEW` View object type.
`static int` | `WHEREPORTION` SQL Where Portion clause object type.
`static int` | `WSDLTYPE_LOCALEFILE` WSDL connection type
`static int` | `WSDLTYPE_URI` WSDL connection type
`static int` | `XML_CONNECTION` XMLConnection object type.
`static int` | `XML_MDCONTAINER` XMLContainer object type.

Fields inherited from class jet.api.API
`CAT, CENTIMETER, COLOR, DOUBLE, ENUM, FLOAT, INCH, LONG, PIXEL, REFERENCE, RPT, SELFRPT, TEXTRPT, UNKNOWN, XMLCAT, XMLRPT`

Method Summary
`boolean` | `checkParam(ParameterInfo info)` Checks whether or not the parameter's definition is valid.
`Designer` | `create(java.lang.String path, java.lang.String name)` Deprecated.
`boolean` | `delete(java.lang.String handle)` Deletes an object from the catalog.
`boolean` | `delete(java.lang.String qryName, java.lang.String tablename)` Deletes the specified table in the query.
`boolean` | `delete(java.lang.String qryName, java.lang.String unionQuery, boolean unionAll)` Deletes the "union query" of the query in the default datasource.
`boolean` | `delete(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname)` Deletes the specified table's column in the query.
`boolean` | `delete(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression)` Deletes the QBE condition in the query.
`boolean` | `delete(java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic)` Deletes where conditions in the query.
`boolean` | `delete(java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo)` Deletes a join of the query.
`boolean` | `delete(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo)` Deletes a join in the query
`boolean` | `delete(java.lang.String dataSourceName, java.lang.String qryName, UnionInfo info)` Deletes the "union query" of the query in the specified data source.
`boolean` | `delete(java.lang.String qryName, UnionInfo info)` Deletes the "union query" of the query.
`boolean` | `deleteCompCol(java.lang.String qryName, java.lang.String columnName)` Deletes the Computed Column from the query.
`boolean` | `deleteCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName)` Deletes the Computed Column from the query.
`boolean` | `deleteCondition(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic)` Deletes where conditions in the query.
`boolean` | `deleteQBE(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression)` Deletes the QBE condition in the query.
`boolean` | `deleteQuery(java.lang.String qryName)` Deletes the query from the data source.
`boolean` | `deleteQuery(java.lang.String dataSourceName, java.lang.String qryName)` Deletes the query from the specified data source.
`boolean` | `deleteQueryField(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname)` Deletes the specified table's column in the query of the specified data source.
`boolean` | `deleteQueryTable(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename)` Deletes the specified table in the query of the specified data source.
`boolean` | `deleteUnionQuery(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String unionQuery, boolean unionAll)` Deletes the "union query" of the query in the specified data source.
`java.lang.String[][]` | `getAndConditions(java.lang.String queryName)` Deprecated. Replaced by `getAndInfos(String queryName)`
`java.lang.String[][]` | `getAndConditions(java.lang.String dataSourceName, java.lang.String queryName)` Deprecated. -Replaced by `getAndInfos(String dataSourceName, String queryName)`
`AndInfo[]` | `getAndInfos(java.lang.String queryName)` Gets "And" filter condition information of the query
`AndInfo[]` | `getAndInfos(java.lang.String dataSourceName, java.lang.String queryName)` Gets "And" filter condition information of the query in the specified data source.
`java.lang.String[]` | `getBLCategoryHandles(java.lang.String handle)` Gets Business Logic (also named Business/Report Cube) category handles in the specified Business Logic node.
`java.lang.String[]` | `getBLDetailHandles(java.lang.String handle)` Gets Business Logic (also named Business/Report Cube) Detail Information handles in the specified Business Logic node.
`java.lang.String[]` | `getBLDimensionHandles(java.lang.String handle)` Gets Business Logic (also named Business/Report Cube) Dimension handles in the specified Business Logic node.
`BLFilterInformation` | `getBLFilterInfo(java.lang.String handle)` Gets predefined Business Logic (also named Business/Report Cube/Business View) filter information.
`BLFilterInformation[]` | `getBLFilterInfos(java.lang.String handle)` Gets predefined filter's information of a Business Logic (also named Business/Report Cube/Business View).
`java.lang.String[]` | `getBLHierarchyHandles(java.lang.String handle)` Gets Business Logic (also named Business/Report Cube) Hierarchy handles in the specified Business Logic node.
`java.lang.String[]` | `getBLMeasureHandles(java.lang.String handle)` Gets Business Logic (also named Business/Report Cube) Measure handles in the specified Business Logic node.
`java.lang.String` | `getBLNodeQualifyName(java.lang.String handle)` Gets BusinessLogic node's qualified name.
`java.lang.String[]` | `getBLViewHandles(java.lang.String dataSourceName)` Gets Business Logic (also named Business/Report Cube) handles in the specified data source.
`java.lang.String[]` | `getBLViewHandles(java.lang.String dataSourceName, int queryType)` Gets Business Logic (also named Business/Report Cube) handles by the specified query type in the specified data source.
`java.lang.String[]` | `getBLViewNames(java.lang.String dataSourceName)` Gets Business Logic (also named Business/Report Cube) names in the specified data source.
`java.lang.String[]` | `getBLViewNames(java.lang.String dataSourceName, int queryType)` Gets Business Logic (also named Business/Report Cube) names in the specified data source.
`java.lang.String[]` | `getBusinessNodeNames(java.lang.String dataSourceName, java.lang.String businessViewName)` Gets business node names of the specified Business Logic (also named Business/Report Cube) in the specified data source.
`java.lang.String[]` | `getBusinessViewAggregationHandles(java.lang.String handle)` Gets Business View Aggregation handles in the specified Business Logic node.
`java.lang.String[]` | `getBusinessViewDetailHandles(java.lang.String handle)` Gets Business View detail handles in the specified Business Logic node.
`java.lang.String[]` | `getBusinessViewGroupHandles(java.lang.String handle)` Gets Business View Group handles in the specified Business Logic node.
`java.lang.String[]` | `getBusinessViewHandles(java.lang.String dataSourceName)` Gets Business View handles by the specified query type in the specified data source.
`java.lang.String[]` | `getBusinessViewHandles(java.lang.String dataSourceName, int queryType)` Gets Business View handles by the specified query type in the specified data source.
`java.lang.String[]` | `getBusinessViewNames(java.lang.String dataSourceName)` Gets Business View names in the specified data source.
`java.lang.String[]` | `getBusinessViewNames(java.lang.String dataSourceName, int queryType)` Gets Business View names in the specified data source.
`java.lang.String[]` | `getBusinesViewCategoryHandles(java.lang.String handle)` Gets Business View category handles in the specified Business Logic node.
`java.lang.String[]` | `getChartFunctions(java.lang.String queryName, java.lang.String groupBy)` Gets formulas and summaries which are valid to the query and can be grouped on this field.
`java.lang.String[]` | `getChartFunctions(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy)` Gets formulas and summaries which are valid to the query and can be grouped on this field.
`java.lang.String[]` | `getColumnMappingnames(java.lang.String queryName)` Gets all columns' mapping names in the query.
`java.lang.String[]` | `getColumnMappingnames(java.lang.String dataSourceName, java.lang.String queryName)` Gets all columns' mapping names in the query.
`QueryTableInfo` | `getColumns(java.lang.String queryName, boolean allColumns)` Gets definitions of all tables and columns in the query.
`QueryTableInfo` | `getColumns(java.lang.String dataSourceName, java.lang.String queryName, boolean allColumns)` Gets definitions of all tables and columns in the query.
`QueryTableInfo` | `getColumnsCanBeGroupedBy(java.lang.String queryName)` Gets columns in the query which can be used to group data in the report.
`QueryTableInfo` | `getColumnsCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName)` Gets columns in the query which can be used to group data in the report.
`java.lang.String[]` | `getCompColumnHandles(java.lang.String dataSourceName, java.lang.String queryName)` Gets handles of the computed columns in the query
`java.lang.String[]` | `getCompColumns(java.lang.String queryName)` Gets computed columns in the query
`java.lang.String[]` | `getCompColumns(java.lang.String dataSourceName, java.lang.String queryName)` Gets computed columns in the query
`ConnectionInfo` | `getConnectionInfo()` Gets connection information from the default data source.
`ConnectionInfo` | `getConnectionInfo(java.lang.String dataSourceName)` Gets connection information from the specified data source.
`ConnectionInfo` | `getConnectionInfo(java.lang.String dataSourceName, java.lang.String connectionName)` Gets connection information from the specified data source.
`java.lang.String[]` | `getDataSources()` Gets all Data Source names in the catalog.
`java.lang.String[]` | `getDBFields(java.lang.String qryName)` Gets DBFields' mapping names that are defined in the query of the specified data source.
`java.lang.String[]` | `getDBFields(java.lang.String dataSourceName, java.lang.String qryName)` Gets DBFields' mapping names that are defined in the query of the specified data source.
`java.lang.String` | `getDefaultConnectionName(java.lang.String datasourceName)` Gets the resource name of the default connection in the specified data source.
`java.lang.String` | `getDefaultDataSourceName()` Gets the data source name of the default data source.
`java.lang.String[]` | `getForeignKeys(java.lang.String tablename)` Gets foreign keys of the table.
`java.lang.String[]` | `getForeignKeys(java.lang.String dataSourceName, java.lang.String tablename)` Gets foreign keys of the table.
`java.lang.String[]` | `getForeignKeys(java.lang.String dataSourceName, java.lang.String connectionName, java.lang.String tablename)` Gets foreign keys of the table.
`java.lang.String[]` | `getFormulae()` Gets all formulas' mapping names that are defined in the default datasource.
`java.lang.String[]` | `getFormulae(java.lang.String dataSourceName)` Gets all formulas' mapping names that are defined in the specified data source.
`java.lang.String[]` | `getFormulaeCanBeGroupedBy(java.lang.String queryName)` Gets formulas which are valid to the query and can be grouped on.
`java.lang.String[]` | `getFormulaeCanBeGroupedBy(java.lang.String queryName, java.lang.String groupBy)` Gets formulas which are valid to the query and can be grouped on this field.
`java.lang.String[]` | `getFormulaeCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy)` Gets formulas which are valid to the query and can be grouped on this field.
`java.lang.String[]` | `getFormulaeForQuery(java.lang.String queryName)` Gets formulas which are valid to the query.
`java.lang.String[]` | `getFormulaeForQuery(java.lang.String dataSourceName, java.lang.String queryName)` Gets formulas which are valid to the query.
`FormulaInfo` | `getFormulaInfo(java.lang.String handle)` Gets the Formula's information.
`java.lang.String[]` | `getFormulasCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName)` Gets formulas which are valid to the query and can be grouped on The "valid" means that the formulas and their referred fields are the valid fields in the specified query.
`java.lang.String[]` | `getFunctions(int iType)` Gets available embedded function names according to SQL type.
`java.lang.String[]` | `getFunctions(java.lang.String resourceName)` Gets available embedded function names according to the field mapping name.
`java.lang.String[]` | `getFunctions(java.lang.String dataSourceName, java.lang.String resourceName)` Gets available embedded function names according to the field mapping name in the specified data source.
`java.lang.String` | `getHandle(java.lang.String resourceName, int type)` Gets the handle of an object according to the object's resource name and object type, which can identify the object in the catalog.
`java.lang.String` | `getHandle(java.lang.String dataSourceName, java.lang.String resourceName, int type)` Gets the handle of an object according to the object's resource name and object type in the specified data source in JReport catalog, which can identify the object in the catalog.
`java.lang.String[]` | `getHDSs()` Gets all resource names of Hierarchical Data Sources (HDS) query that are defined in the default data source.
`java.lang.String[]` | `getHDSs(java.lang.String dataSourceName)` Gets all resource names of Hierarchical Data Sources (HDS) query that are defined in the specified data source.
`JoinInfo[]` | `getJoinInfos(java.lang.String queryName)` Gets joins' definitions in the query of default datasource.
`JoinInfo[]` | `getJoinInfos(java.lang.String dataSourceName, java.lang.String queryName)` Gets joins' definitions in the query.
`java.lang.String[][]` | `getJoins(java.lang.String queryName)` Deprecated. Replaced by `getJoinInfos(String queryName)` Gets joins definition in the query.
`java.lang.String[][]` | `getJoins(java.lang.String dataSourceName, java.lang.String queryName)` Deprecated. Replaced by `getJoinInfos(String dataSourceName, String queryName)` Gets joins definition in the query.
`QueryTableInfo` | `getMapColumns(java.lang.String queryName)` Gets definitions of all tables and columns in the query.
`QueryTableInfo` | `getMapColumns(java.lang.String dataSourceName, java.lang.String queryName)` Gets definitions of all tables and columns in the query.
`java.lang.String` | `getMappingname(java.lang.String handle)` Gets a resource name for the specified catalog object by its handle.
`java.lang.String[]` | `getMappingnames(java.lang.String DSName)` Gets the fields' mapping names in default data source.
`java.lang.String[]` | `getMappingnames(java.lang.String dataSourceName, java.lang.String DSName)` Gets the fields' mapping names in the specified data source
`java.lang.String` | `getNewFormulaName()` Gets a default formula name for the formula to be created in the current catalog,which is unique in the specified data source.
`java.lang.String` | `getNewFormulaName(java.lang.String sourceName)` Gets a default mapping name for the formula to be created in the specified data source of the current catalog, which is unique in the specified data source.
`java.lang.String` | `getNewQueryName()` Gets a default resource name for the query to be created in the current catalog, which is unique in the specified data source.
`java.lang.String` | `getNewQueryName(java.lang.String sourceName)` Gets a default resource name for the query to be created in the specified data source of the current catalog, which is unique in the specified data source.
`java.lang.String` | `getNewReportName()` Gets a default report name for the report to be created, which must be unique.
`ObjectInfo` | `getObjectInfo(java.lang.String handle)` Gets resource entity's information of an object in the catalog.
`ObjectInfo` | `getObjectInfo(java.lang.String resourceName, int type)` Gets resource entity's information of an object in catalog.
`ObjectInfo` | `getObjectInfo(java.lang.String dataSourceName, java.lang.String resourceName, int type)` Gets resource entity's information of an object in the catalog.
`java.lang.String[]` | `getParameter()` Gets mapping names of the parameters defined in the default data source.
`java.lang.String[]` | `getParameter(java.lang.String dataSourceName)` Gets mapping names of the parameters defined in the specified data source.
`java.lang.String[]` | `getParameterCanBeGroupedBy()` Gets parameters which can be used to group by in the report from the default data source.
`java.lang.String[]` | `getParameterCanBeGroupedBy(java.lang.String dataSourceName)` Gets parameters which can be used to group by in the report from the specified data source.
`ParameterInfo` | `getParameterInfo(java.lang.String handle)` Gets the parameter's information.
`java.lang.String[]` | `getPredifinedFilterHandles(java.lang.String handle)` Gets the predefined Business Logic filters' handle of the specified Business Logic (also named Business/Report Cube/Business View) .
`java.lang.String[]` | `getPrimaryKeys(java.lang.String tablename)` Gets Primary keys of the table.
`java.lang.String[]` | `getPrimaryKeys(java.lang.String dataSourceName, java.lang.String tablename)` Gets Primary keys of the table in the default connection of the specified data source.
`java.lang.String[]` | `getPrimaryKeys(java.lang.String dataSourceName, java.lang.String connectionName, java.lang.String tablename)` Gets Primary keys of the table in the specified data source and connection.
`java.lang.String[]` | `getProcColumns(java.lang.String procedureName)` Gets all column names of the specified Stored Procedure query that are defined in the default data source.
`java.lang.String[]` | `getProcColumns(java.lang.String dataSourceName, java.lang.String procedureName)` Gets all column names of the specified Stored Procedure query that are defined in the specified data source.
`java.lang.String[]` | `getProcColumnsMap(java.lang.String procedureName)` Gets all columns' mapping names of the specified Stored Procedure query that are defined in the default data source.
`java.lang.String[]` | `getProcColumnsMap(java.lang.String dataSourceName, java.lang.String procedureName)` Gets all columns' mapping names of the specified Stored Procedure query that are defined in the specified data source.
`java.lang.String[]` | `getProcedureNames()` Gets all resource names of Stored Procedure query that are defined in the default data source.
`java.lang.String[]` | `getProcedureNames(java.lang.String dataSourceName)` Gets all resource names of Stored Procedure query that are defined in the default data source.
`java.lang.String[][]` | `getQBEInfo(java.lang.String queryName)` Deprecated. -Replaced by `getQBEInfos(String queryName)` Gets QBE information in the query.
`java.lang.String[][]` | `getQBEInfo(java.lang.String dataSourceName, java.lang.String queryName)` Deprecated. Replaced by `getQBEInfos(String dataSourceName, String queryName)` Gets QBE information in the query
`QBEInfo[]` | `getQBEInfos(java.lang.String queryName)` Gets "QBE" condition information of the query.
`QBEInfo[]` | `getQBEInfos(java.lang.String dataSourceName, java.lang.String queryName)` Gets "QBE" condition information of the query in the specified data source.
`java.lang.String[]` | `getQueries()` Gets all resource names of the Query that are defined in the default data source.
`java.lang.String[]` | `getQueries(java.lang.String dataSourceName)` Gets all resource names of the Query that are defined in the specified data source.
`java.lang.String` | `getQuoteChar()` Gets the quote char from the default JDBC connection of default data source.
`java.lang.String` | `getQuoteChar(java.lang.String dataSourceName)` Gets the quote char from the JDBC connection of the specified data source
`java.lang.String` | `getQuoteChar(java.lang.String dataSourceName, java.lang.String connectionName)` Gets the quote char from the specified JDBC connection.
`java.lang.String[]` | `getSPFields(java.lang.String dataSourceName, java.lang.String procedureName, boolean isMapping)` Gets field names of the specified stored procedure's fields.
`java.lang.String[]` | `getSPFieldsMap(java.lang.String dataSourceName, java.lang.String procedureName, boolean isMapping)` Gets mapping names of the specified stored procedure's fields.
`java.lang.String[]` | `getSQLColumns(java.lang.String sqlname)` Gets all columns' real names of the specified Imported SQL query that are defined in the default data source.
`java.lang.String[]` | `getSQLColumns(java.lang.String dataSourceName, java.lang.String sqlname)` Gets all columns' real names of the specified Imported SQL query that are defined in the specified data source.
`java.lang.String[]` | `getSQLColumnsMap(java.lang.String sqlname)` Gets all columns' mapping names of the specified Imported SQL query that are defined in the default data source.
`java.lang.String[]` | `getSQLColumnsMap(java.lang.String dataSourceName, java.lang.String sqlname)` Gets all columns' mapping names of the specified Imported SQL query that are defined in the specified data source.
`java.lang.String[]` | `getSQLs()` Gets all Imported SQL queries' resource names that are defined in the default data source.
`java.lang.String[]` | `getSQLs(java.lang.String dataSourceName)` Gets all Imported SQL queries' resource names that are defined in the specified data source.
`java.lang.String` | `getSQLString(java.lang.String queryName)` Gets sql statement text of a queriable object.
`java.lang.String` | `getSQLString(java.lang.String dataSourceName, java.lang.String queryName)` Gets sql statement text of a queriable object.
`int` | `getSQLType(java.lang.String query, java.lang.String colName)` Gets sql type of a query column.
`int` | `getSQLType(java.lang.String sourceName, java.lang.String qryName, java.lang.String columnName)` Gets sql type of a query column.
`java.lang.String[]` | `getSubQueries(java.lang.String queryName)` Gets the "subquery" names of the query.
`java.lang.String[]` | `getSubQueries(java.lang.String dataSourceName, java.lang.String queryName)` Gets "subquery" names of the query.
`java.lang.String[]` | `getSummaries()` Gets all Summaries' mapping names that are defined in the default data source.
`java.lang.String[]` | `getSummaries(java.lang.String dataSourceName)` Gets all Summaries' mapping names that are defined in the specified data source.
`java.lang.String[]` | `getSummariesForQuery(java.lang.String queryName)` Gets Summaries which are valid to the query.
`java.lang.String[]` | `getSummariesForQuery(java.lang.String dataSourceName, java.lang.String queryName)` Gets Summaries which are valid to the query.
`java.lang.String[]` | `getSummaryCanBeSortedBy(java.lang.String queryName, java.lang.String groupBy)` Gets the summaries which can be sorted by in a report group.
`java.lang.String[]` | `getSummaryCanBeSortedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy)` Gets the summaries which can be sorted by in a report group.
`SummaryInfo` | `getSummaryInfo(java.lang.String handle)` Gets the Summary's information.
`java.lang.String[]` | `getTableColumns(java.lang.String tablename)` Gets all columns' real names of the Table/View that are defined in the default data source.
`java.lang.String[]` | `getTableColumns(java.lang.String tablename, boolean isMapping)` Gets all column names of the Table/View that are defined in the default data source.
`java.lang.String[]` | `getTableColumns(java.lang.String dataSourceName, java.lang.String tablename)` Gets all columns' real names of the Table/View that are defined in the specified data source.
`java.lang.String[]` | `getTableColumns(java.lang.String dataSourceName, java.lang.String tablename, boolean isMapping)` Gets all column names of the Table/View that are defined in the specified data source.
`java.lang.String[]` | `getTableColumnsMap(java.lang.String tablename)` Gets all columns' mapping names of the Table/View that are defined in the default data source.
`java.lang.String[]` | `getTableColumnsMap(java.lang.String tablename, boolean isMapping)` Gets all columns' mappping names of the Table/View that are defined in the default data source.
`java.lang.String[]` | `getTableColumnsMap(java.lang.String dataSourceName, java.lang.String tablename)` Gets all columns' mapping names of the Table/View that are defined in the specified data source.
`java.lang.String[]` | `getTableColumnsMap(java.lang.String dataSourceName, java.lang.String tablename, boolean isMapping)` Gets all columns' mapping names of the Table/View that are defined in the specified data source.
`java.lang.String[]` | `getTables()` Gets all mapping names of the Table/View that are defined in the default data source.
`java.lang.String[]` | `getTables(boolean bIncludeSystemTable)` Gets names of tables and views in the database that was defined in the default datasource of catalog.
`java.lang.String[]` | `getTables(java.lang.String dataSourceName)` Gets all mapping names of the Table/View that are defined in the specified data source.
`java.lang.String[]` | `getTables(java.lang.String dataSourceName, boolean bIncludeSystemTable)` Gets names of tables and views in the database that was defined in the specified datasource of catalog.
`java.lang.String[]` | `getTables(java.lang.String dataSourceName, java.lang.String connectionName, boolean bIncludeSystemTable)` Gets names of tables and views in the database that was defined in the specified datasource of catalog.
`java.lang.String[]` | `getUDSColumns(java.lang.String udsname)` Gets all column names of the specified UDS query that are defined in the specified data source.
`java.lang.String[]` | `getUDSColumns(java.lang.String dataSourceName, java.lang.String udsname)` Gets all column names of the specified UDS query that are defined in the specified data source.
`java.lang.String[]` | `getUDSColumnsMap(java.lang.String udsname)` Gets all columns' mapping names of the specified UDS query that are defined in the specified data source.
`java.lang.String[]` | `getUDSColumnsMap(java.lang.String dataSourceName, java.lang.String udsname)` Gets all columns' mapping names of the specified UDS query that are defined in the specified data source.
`java.lang.String[]` | `getUDSs()` Gets all resource names of User Data Source(UDS) query that are defined in the specified data source.
`java.lang.String[]` | `getUDSs(java.lang.String dataSourceName)` Gets all resource names of User Data Source(UDS) query that are defined in the specified data source.
`java.lang.String[]` | `getUnionableQueries(java.lang.String queryname)` Gets available query names that can be unioned to this query.
`java.lang.String[]` | `getUnionableQueries(java.lang.String dataSourceName, java.lang.String queryname)` Gets available query names that can be unioned to this query.
`UnionInfos` | `getUnionInfos(java.lang.String queryName)` Gets union query information of a specified query
`UnionInfos` | `getUnionInfos(java.lang.String dataSourceName, java.lang.String queryName)` Gets union query information of the query of the specified data source.
`java.lang.String[]` | `getUnionQueries(java.lang.String queryName)` Gets unioned query names of the specified query.
`java.lang.String[]` | `getUnionQueries(java.lang.String queryName, boolean isUnionAll)` Gets unioned query names of a specified query according to the union status
`java.lang.String[]` | `getUnionQueries(java.lang.String dataSourceName, java.lang.String queryName)` Gets unioned query names of the specified query.
`java.lang.String[]` | `getUnionQueries(java.lang.String dataSourceName, java.lang.String queryName, boolean isUnionAll)` Gets unioned query names of a specified query according to the union status
`java.lang.String` | `getUserID()` Gets the user's ID of this `CatalogAPI` instance
`java.lang.String` | `insert(boolean bUseJDBCODBCBridge, java.lang.String name, java.lang.String desc, java.lang.String url, java.lang.String driver)` Inserts a JReport database connection object.
`java.lang.String` | `insert(boolean bUseJDBCODBCBridge, java.lang.String strName, java.lang.String strDesc, java.lang.String URL, java.lang.String driver, ConnectionInfo info)` Inserts a JReport database connection object into the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, boolean bUseJDBCODBCBridge, java.lang.String name, java.lang.String desc, java.lang.String url, java.lang.String driver)` Inserts a JReport database connection object into the database.
`java.lang.String` | `insert(java.lang.String dataSourceName, boolean bUseJDBCODBCBridge, java.lang.String strName, java.lang.String strDesc, java.lang.String URL, java.lang.String driver, ConnectionInfo info)` Inserts a JReport database connection object into the specified data source.
`java.lang.String` | `insert(java.lang.String name, int type)` Adds a resource entity into the catalog.
`java.lang.String` | `insert(java.lang.String qryName, QueryFieldInfo queryFieldInfo, QueryJoinInfo queryJoinInfo, QueryQBEInfo queryQBEInfo, QueryAndInfo queryAndInfo)` Inserts a query into the catalog.
`java.lang.String` | `insert(java.lang.String SQLName, java.lang.String filename)` Inserts an imported query into the default Connection of the default data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String name, int type)` Adds a resource entity into a specified data source in the catalog.
`java.lang.String` | `insert(java.lang.String summaryName, java.lang.String desc, int functionType, java.lang.String fieldName, java.lang.String groupByFld)` Adds an aggregate function into the data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String qryName, QueryFieldInfo queryFieldInfo, QueryJoinInfo queryJoinInfo, QueryQBEInfo queryQBEInfo, QueryAndInfo queryAndInfo)` Inserts a query into the catalog.
`java.lang.String` | `insert(java.lang.String formulaName, java.lang.String desc, java.lang.String expression)` Adds a formula into the data source.
`java.lang.String` | `insert(java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type)` Inserts a table or view into the data source.
`java.lang.String` | `insert(java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type, boolean setMappingName)` Inserts a table or view into the data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String summaryName, java.lang.String desc, int functionType, java.lang.String fieldName, java.lang.String groupByFld)` Adds an aggregate function into the data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String formulaName, java.lang.String desc, java.lang.String expression)` Adds a formula into the specified data source.
`java.lang.String` | `insert(java.lang.String tableName, java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type, boolean setMappingName)` Inserts a table or view into the data source.
`java.lang.String` | `insert(java.lang.String tableName, java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type, java.lang.String character)` Inserts a table or view into the data source.
`java.lang.String` | `insert(java.lang.String parameterName, java.lang.String desc, java.lang.String prompt, java.lang.String type, java.lang.String defaultValue)` Inserts a JReport parameter object into the data source.
`java.lang.String` | `insert(java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType)` Inserts a stored procedure into a Connection of the default data source.
`java.lang.String` | `insert(java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType, boolean setMappingName)` Inserts a stored procedure into a Connection of the default data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String tableName, java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type, java.lang.String character)` Inserts a table or view into the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String parameterName, java.lang.String desc, java.lang.String prompt, java.lang.String type, java.lang.String defaultValue)` Inserts a JReport parameter object into the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType, boolean setMappingName)` Inserts a stored procedure into a Connection of the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType, boolean setMappingName, java.lang.String connector)` Inserts a stored procedure into the default Connection of the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType, java.lang.String connector)` Inserts a stored procedure into a Connection of the specified data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String strDSName, java.lang.String strClassName, java.lang.String strParameter, UDSColumnInfo udsColInfo)` Inserts a User Defined Datasource(UDS) into specified data source.
`java.lang.String` | `insert(java.lang.String strDSName, java.lang.String strClassName, java.lang.String strParameter, UDSColumnInfo udsColInfo)` Inserts a User Defined Datasource(UDS) into the data source.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String wherePotionName, java.lang.String desc, WherePortionInfo whereportionInfo)` Inserts a predefined WherePortion into the specified data source.
`java.lang.String` | `insert(java.lang.String wherePotionName, java.lang.String desc, WherePortionInfo whereportionInfo)` Inserts a predefined WherePortion into the data source.
`java.lang.String` | `insertBLCategory(java.lang.String parentHandle, BLCategoryInfo info)` Inserts a Business Logic Category object into the specified container.
`java.lang.String` | `insertBLDetail(java.lang.String parentHandle, BLDetailInfo info)` Inserts a BusinessLogic (also named Business/Report Cube) Detail information object into the specified container object Detail information objects provide additional information.
`java.lang.String` | `insertBLDimension(java.lang.String parentHandle, BLDimensionInfo info)` Inserts a Business Logic (also named Business/Report Cube) Dimension object into the specified object.
`java.lang.String` | `insertBLHierarchy(java.lang.String blViewHandle, BLHierarchyInfo info)` Inserts a Business Logic (also named Business/Report Cube) Hierarchy object into the specified object.
`java.lang.String` | `insertBLMeasure(java.lang.String parentHandle, BLMeasureInfo info)` Inserts a Business Logic (also named Business/Report Cube) Measure objectinto the specified object.
`java.lang.String` | `insertBusinessView(java.lang.String dataSourceName, java.lang.String queriableName, java.lang.String businessViewName)` Inserts a Business Logic into the specified queriable object.
`java.lang.String` | `insertBusinessView(java.lang.String dataSourceName, java.lang.String queriableName, java.lang.String businessViewName, boolean isLogicView)` Inserts a Business Logic/View into the specified queriable object.
`java.lang.String` | `insertBusinessViewAggregation(java.lang.String parentHandle, BVAggregationInfo info)` Inserts a Business View Aggregation object into the specified object.
`java.lang.String` | `insertBusinessViewCategory(java.lang.String parentHandle, BLCategoryInfo info)` Deprecated.
`java.lang.String` | `insertBusinessViewCategory(java.lang.String parentHandle, BusinessViewCategoryInfo info)` Inserts a Business View Category object into the specified object.
`java.lang.String` | `insertBusinessViewDetail(java.lang.String parentHandle, BVDetailInfo info)` Inserts a Business View Detail object into the specified container object.
`java.lang.String` | `insertBusinessViewGroup(java.lang.String parentHandle, BVGroupInfo info)` Inserts a Business View Group object into the specified object.
`java.lang.String` | `insertClassHDS(java.lang.String dataSourceName, java.lang.String name, java.lang.String classPath, java.lang.String parameter)` Inserts a hierarchical data sources (HDS) into the catalog.
`java.lang.String` | `insertCompCol(java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression)` Inserts a Computed Column into the query.
`java.lang.String` | `insertCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression)` Inserts a Computed Column into the query of the specified data source.
`java.lang.String` | `insertPredefinedBLFilterInfo(java.lang.String blHandle, BLFilterInformation filterInfo)` Adds predefined Business Logic filter into the specified Business Logic (also named Business/Report Cube/Business View) .
`java.lang.String` | `insertSql(java.lang.String dataSourceName, java.lang.String SQLName, java.lang.String filename)` Inserts an imported query into a Connection of the specified data source.
`java.lang.String` | `insertSql(java.lang.String dataSourceName, java.lang.String connectionName, java.lang.String SQLName, java.lang.String filename)` Inserts an imported query into the specified Connection of the specified data source.
`java.lang.String` | `insertStoredProcedure(java.lang.String dataSourceName, java.lang.String connectionName, java.lang.String procName, java.lang.String catalog, java.lang.String schema, java.lang.String name, java.lang.String remarks, int iType, boolean setMappingName, java.lang.String connector)` Inserts a stored procedure into the specified Connection of the specified data source.
`java.lang.String` | `insertTable(java.lang.String dataSourceName, java.lang.String connectionName, java.lang.String tableName, java.lang.String catalogName, java.lang.String schemaPattern, java.lang.String tablePattern, int type, java.lang.String character)` Inserts a table or view into the specified data source.
`java.lang.String` | `insertWSDLConnection(java.lang.String dataSourceName, java.lang.String strName, java.lang.String strDesc, java.lang.String URI, int uriType, ConnectionInfo info)` Inserts a JReport WebService-based connection object into the specified data source.
`java.lang.String` | `insertXMLHDS(java.lang.String dataSourceName, java.lang.String name, java.lang.String xmlPath, java.lang.String xsdPath)` Inserts a hierarchical data sources (HDS) into the catalog.
`boolean` | `isDistinctQuery(java.lang.String dataSourceName, java.lang.String queryName)` Geta the distinct status of the query
`boolean` | `isModified()` Checks whether or not the catalog has been modified.
`boolean` | `isNameExist(java.lang.String name)` Determines whether or not the resource entity exists in the catalog.
`boolean` | `isNameExist(java.lang.String dataSourceName, java.lang.String name)` Determines whether or not the resource entity exists in the specified data source of the catalog.
`java.lang.String` | `mapFunction(int function)` Converts aggregate function type from number to String.
`java.lang.String` | `parseFormula(FormulaInfo info)` Parses a formula definition in the data source.
`java.lang.String` | `parseFormula(java.lang.String dataSourceName, FormulaInfo info)` Parses a formula definition in the data source.
`java.lang.String` | `parseFormulae()` Parses all formulas in the data source.
`java.lang.String` | `parseFormulae(java.lang.String dataSourceName)` Parses all formulas in the specified data source.
`boolean` | `refreshReference()` Creates a new or refreshes an existing CrossReference with `CrossReferenceConfigure`.
`void` | `rename(java.lang.String resourceName, java.lang.String newName, int type)` Renames the specified object.
`void` | `rename(java.lang.String dataSourceName, java.lang.String resourceName, java.lang.String newName, int type)` Renames the resource name of the specified object.
`boolean` | `save()` Saves an open catalog.
`boolean` | `saveAs(java.lang.String path, java.lang.String name)` Saves an open catalog as a new catalog file.
`boolean` | `set(java.lang.String qryName, AndInfo andInfo)` Adds a new and condition to the query.
`boolean` | `set(java.lang.String handle, FormulaInfo info)` Sets the Formula's information.
`boolean` | `set(java.lang.String qryName, JoinInfo joinInfo)` Adds a new SQL join into the query of the data source.
`boolean` | `set(java.lang.String handle, ParameterInfo info)` Sets the parameter's information.
`boolean` | `set(java.lang.String qryName, QBEInfo qbeInfo)` Adds a QBE condition into the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, AndInfo andInfo)` Adds a new and condition to the query
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, JoinInfo joinInfo)` Adds a new SQL join into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, boolean isFormula)` Adds a table's field into the query of the default data source.
`boolean` | `set(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression)` Adds a QBE condition into the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, boolean isFormula)` Adds a new table's field into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic)` Adds a new where condition into the query.
`boolean` | `set(java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo)` Adds a new SQL join into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, boolean isSQL92, int outerJoin)` Adds a new join to the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, boolean isSQL92, int outerJoin)` Adds a new join to the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, SubQueryInfo subqueryInfo)` Adds a subquery into the query of the specified data source.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, UnionInfo unionInfo)` Adds a union query into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, SubQueryInfo subqueryInfo)` Adds a subquery into the query.
`boolean` | `set(java.lang.String handle, SummaryInfo info)` Sets the Summary's information.
`boolean` | `set(java.lang.String qryName, UnionInfo unionInfo)` Adds a union query into the specified query.
`boolean` | `setCompCol(java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression)` Modifies the Computed Column in the query.
`boolean` | `setCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression)` Modifies the Computed Column in the query.
`boolean` | `setCondition(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic)` Adds a new where condition to the specified query.
`void` | `setDefaultConnection(java.lang.String datasourceName, java.lang.String connectionName)` Sets the specified connection as the `default` in the specified datasource.
`boolean` | `setDefaultDataSource(java.lang.String datasourceName)` Sets the specified data source as the default data source.
`boolean` | `setDistinctQuery(java.lang.String dataSourceName, java.lang.String queryName, boolean isDisTinct)` set the distinct status of the query
`boolean` | `setJoin(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo)` Adds a new SQL join into the query of the specified data source.
`void` | `setModified(boolean isModified)` Sets the modifying status of the Catalog.
`boolean` | `setQBE(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression)` Adds a QBE condition into the query.
`boolean` | `setQueryField(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, boolean isMapping, boolean isFormula)` Adds a new table's field into the query of the specified data source.
`boolean` | `setQueryTable(java.lang.String qryName, java.lang.String tablename, boolean selectAllFields)` Adds a new table into the query of default data source.
`boolean` | `setQueryTable(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, boolean selectAllFields)` Adds a new table into the query of the specified data source.
`boolean` | `setQueryTable(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, boolean isMapping, boolean selectAllFields)` Adds a new table into the query of the specified data source.
`java.lang.String` | `updateSQLFile(java.lang.String SQLName, java.lang.String filename)` Updates an imported query of a Connection of the data source.
`java.lang.String` | `updateSQLFile(java.lang.String dataSourceName, java.lang.String SQLName, java.lang.String filename)` Updates an imported query of a Connection of the data source.
`boolean` | `updateUDS(java.lang.String userDataSourceName)` Updates UDS in the default Data Source of the Catalog.
`boolean` | `updateUDS(java.lang.String dataSourceName, java.lang.String userDataSourceName)` Updates UDS in the specified Data Source of the Catalog.

Methods inherited from class jet.api.API
`clearError, clearMsg, clearWarning, closeLog, containPropName, getBool, getChildren, getClassType, getColor, getDouble, getError, getFloat, getHandles, getHandles, getHandles, getHandles, getInstanceName, getInt, getLong, getParent, getPropNames, getPropType, getQualifyName, getString, getStringArray, getUnit, getWarning, set, set, set, set, set, set, set, setLog, setLog, setLog, setReference, setUnit, writeLog, writeLog`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CATALOG

    public static final int CATALOG

  Catalog object type.

  See Also:
    Constant Field Values

### CONNECTION

    public static final int CONNECTION

  Connection object type.

  See Also:
    Constant Field Values

### TABLE

    public static final int TABLE

  Table object type.

  See Also:
    Constant Field Values

### VIEW

    public static final int VIEW

  View object type.

  See Also:
    Constant Field Values

### COLUMN

    public static final int COLUMN

  Column object type.

  See Also:
    Constant Field Values

### QUERY

    public static final int QUERY

  Query object type

  See Also:
    Constant Field Values

### PROCEDURE

    public static final int PROCEDURE

  Stored Procedure object type.

  See Also:
    Constant Field Values

### FILESQL

    public static final int FILESQL

  Imported SQL object type.

  See Also:
    Constant Field Values

### UDS

    public static final int UDS

  User Defined DataSource object type.

  See Also:
    Constant Field Values

### FORMULA

    public static final int FORMULA

  Formula object type.

  See Also:
    Constant Field Values

### SUMMARY

    public static final int SUMMARY

  Summary object type.

  See Also:
    Constant Field Values

### PARAMETER

    public static final int PARAMETER

  Parameter object type.

  See Also:
    Constant Field Values

### WHEREPORTION

    public static final int WHEREPORTION

  SQL Where Portion clause object type.

  See Also:
    Constant Field Values

### SYNONYM

    public static final int SYNONYM

  SQL synonym class type.

  See Also:
    Constant Field Values

### ALIAS

    public static final int ALIAS

  SQL alias class type.

  See Also:
    Constant Field Values

### DATABASE

    public static final int DATABASE

  Database object type.

  See Also:
    Constant Field Values

### HDS

    public static final int HDS

  HierDataSource object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC

    public static final int BUSINESSLOGIC

  BusinessLogic (also named Business/Report Cube) object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_CATEGORY

    public static final int BUSINESSLOGIC_CATEGORY

  BusinessLogic (also named Business/Report Cube) Category object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_DIMENSION

    public static final int BUSINESSLOGIC_DIMENSION

  BusinessLogic (also named Business/Report Cube) Dimension object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_MEASURE

    public static final int BUSINESSLOGIC_MEASURE

  BusinessLogic (also named Business/Report Cube) Measure object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_DETAILINFO

    public static final int BUSINESSLOGIC_DETAILINFO

  BusinessLogic (also named Business/Report Cube) Detail object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_HIERARCHY

    public static final int BUSINESSLOGIC_HIERARCHY

  BusinessLogic (also named Business/Report Cube) Hierarchy object type.

  See Also:
    Constant Field Values

### BUSINESSLOGIC_HIERARCHYCONTAINER

    public static final int BUSINESSLOGIC_HIERARCHYCONTAINER

  BusinessLogic (also named Business/Report Cube) Hierarchy container object type.

  See Also:
    Constant Field Values

### ONDEMAND_QUERY

    public static final int ONDEMAND_QUERY

  Demand Query object type.

  See Also:
    Constant Field Values

### XML_CONNECTION

    public static final int XML_CONNECTION

  XMLConnection object type.

  See Also:
    Constant Field Values

### XML_MDCONTAINER

    public static final int XML_MDCONTAINER

  XMLContainer object type.

  See Also:
    Constant Field Values

### BUSINESSVIEW_GROUP

    public static final int BUSINESSVIEW_GROUP

  BusinessView Group object type.

  See Also:
    Constant Field Values

### BUSINESSVIEW_AGGREGATION

    public static final int BUSINESSVIEW_AGGREGATION

  BusinessView AGGREGATION object type.

  See Also:
    Constant Field Values

### BUSINESSVIEW_DETAIL

    public static final int BUSINESSVIEW_DETAIL

  BusinessView DETAIL object type.

  See Also:
    Constant Field Values

### UNIFIEDBUSINESSVIEW

    public static final int UNIFIEDBUSINESSVIEW

  Unified BusinessView object type.

  See Also:
    Constant Field Values

### BUSINESSVIEW

    public static final int BUSINESSVIEW

  BusinessView object type.

  See Also:
    Constant Field Values

### JDBC_ODBC_BRIDGE

    public static final int JDBC_ODBC_BRIDGE

  Connection with JDBC-ODBC bridge

### JDBC

    public static final int JDBC

  Connection with JDBC

### PATTERN_1PART_NAME

    public static final int PATTERN_1PART_NAME

  qualified name pattern

  See Also:
    Constant Field Values

### PATTERN_2PART_NAME

    public static final int PATTERN_2PART_NAME

  qualified name pattern

  See Also:
    Constant Field Values

### PATTERN_3PART_NAME

    public static final int PATTERN_3PART_NAME

  qualified name pattern

  See Also:
    Constant Field Values

### EXTRA_NAME_JDBC

    public static final int EXTRA_NAME_JDBC

  extra name type

  See Also:
    Constant Field Values

### EXTRA_NAME_USERDEFINED

    public static final int EXTRA_NAME_USERDEFINED

  extra name type

  See Also:
    Constant Field Values

### ENCODINGAUTO

    public static final int ENCODINGAUTO

  encoded data type

  See Also:
    Constant Field Values

### ENCODINGYES

    public static final int ENCODINGYES

  encoded data type

  See Also:
    Constant Field Values

### ENCODINGNO

    public static final int ENCODINGNO

  encoded data type

  See Also:
    Constant Field Values

### TRANSACTION_DEFAULT

    public static final int TRANSACTION_DEFAULT

  transaction isolation level value

  See Also:
    Constant Field Values

### TRANSACTION_NONE

    public static final int TRANSACTION_NONE

  transaction isolation level value

  See Also:
    Constant Field Values

### TRANSACTION_READ_UNCOMMITTED

    public static final int TRANSACTION_READ_UNCOMMITTED

  transaction isolation level value

  See Also:
    Constant Field Values

### TRANSACTION_READ_COMMITTED

    public static final int TRANSACTION_READ_COMMITTED

  transaction isolation level value

  See Also:
    Constant Field Values

### TRANSACTION_REPEATABLE_READ

    public static final int TRANSACTION_REPEATABLE_READ

  transaction isolation level value

  See Also:
    Constant Field Values

### TRANSACTION_SERIALIZABLE

    public static final int TRANSACTION_SERIALIZABLE

  transaction isolation level value

  See Also:
    Constant Field Values

### READ_ONLY_DEFAULT

    public static final int READ_ONLY_DEFAULT

  connection Read-only property

  See Also:
    Constant Field Values

### READ_ONLY_TRUE

    public static final int READ_ONLY_TRUE

  connection Read-only property

  See Also:
    Constant Field Values

### READ_ONLY_FALSE

    public static final int READ_ONLY_FALSE

  connection Read-only property

  See Also:
    Constant Field Values

### INTEGER

    public static final java.lang.String INTEGER

  parameter data type

  See Also:
    Constant Field Values

### NUMBER

    public static final java.lang.String NUMBER

  parameter data type

  See Also:
    Constant Field Values

### STRING

    public static final java.lang.String STRING

  parameter data type

  See Also:
    Constant Field Values

### DECIMAL

    public static final java.lang.String DECIMAL

  Deprecated.
  parameter data type

  See Also:
    Constant Field Values

### CURRENCY

    public static final java.lang.String CURRENCY

  parameter data type

  See Also:
    Constant Field Values

### BOOLEAN

    public static final java.lang.String BOOLEAN

  parameter data type

  See Also:
    Constant Field Values

### DATE

    public static final java.lang.String DATE

  parameter data type

  See Also:
    Constant Field Values

### TIME

    public static final java.lang.String TIME

  parameter data type

  See Also:
    Constant Field Values

### DATETIME

    public static final java.lang.String DATETIME

  parameter data type

  See Also:
    Constant Field Values

### BINARY

    public static final java.lang.String BINARY

  Deprecated.
  parameter data type

  See Also:
    Constant Field Values

### PARAMETERS

    public static final java.lang.String PARAMETERS

  parameter data type

  See Also:
    Constant Field Values

### COUNT

    public static final int COUNT

  constant for summary function name

  See Also:
    Constant Field Values

### SUM

    public static final int SUM

  constant for summary function name

  See Also:
    Constant Field Values

### AVERAGE

    public static final int AVERAGE

  constant for summary function name

  See Also:
    Constant Field Values

### MAXIMUM

    public static final int MAXIMUM

  constant for summary function name

  See Also:
    Constant Field Values

### MINIMUM

    public static final int MINIMUM

  constant for summary function name

  See Also:
    Constant Field Values

### POPULATIONSTDDEV

    public static final int POPULATIONSTDDEV

  constant for summary function name

  See Also:
    Constant Field Values

### POPULATIONVARIANCE

    public static final int POPULATIONVARIANCE

  constant for summary function name

  See Also:
    Constant Field Values

### STDDEV

    public static final int STDDEV

  constant for summary function name

  See Also:
    Constant Field Values

### VARIANCE

    public static final int VARIANCE

  constant for summary function name

  See Also:
    Constant Field Values

### DISTINCTCOUNT

    public static final int DISTINCTCOUNT

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_COUNT

    public static final int RUNNING_COUNT

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_DISTINCTCOUNT

    public static final int RUNNING_DISTINCTCOUNT

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_MAXIMUM

    public static final int RUNNING_MAXIMUM

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_MINIMUM

    public static final int RUNNING_MINIMUM

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_AVERAGE

    public static final int RUNNING_AVERAGE

  constant for summary function name

  See Also:
    Constant Field Values

### RUNNING_SUM

    public static final int RUNNING_SUM

  constant for summary function name

  See Also:
    Constant Field Values

### WSDLTYPE_LOCALEFILE

    public static final int WSDLTYPE_LOCALEFILE

  WSDL connection type

  See Also:
    Constant Field Values

### WSDLTYPE_URI

    public static final int WSDLTYPE_URI

  WSDL connection type

  See Also:
    Constant Field Values

Method Detail

### getUserID

    public java.lang.String getUserID()

  Gets the user's ID of this `CatalogAPI` instance

  Returns:
    a String specifying the user's ID of this `CatalogAPI` instance

### save

    public boolean save()
                 throws jet.jetc.WriteFailureException,
                        jet.universe.exception.FMLFileException

  Saves an open catalog. All modifications of the catalog's object will be saved.

  Returns:
    `true` if the catalog object is saved successfully; `false` otherwise.
  Throws:
    `jet.jetc.WriteFailureException` - if the catalog fails to save the catalog file.
    `jet.universe.exception.FMLFileException` - if the catalog fails to compile the java class of the formula in the catalog.

### saveAs

    public boolean saveAs(java.lang.String path,
                          java.lang.String name)

  Saves an open catalog as a new catalog file. All modifications of the catalog's object will be saved.

  Parameters:
    `path` - The file path of the new catalog file. It is the full path of the file.
    `name` - The file name of the new catalog file.
  Returns:
    `true` if the catalog file is saved successfully; `false` otherwise.

### getNewQueryName

    public java.lang.String getNewQueryName()

  Gets a default resource name for the query to be created in the current catalog, which is unique in the specified data source. For example, the first query name is query1, the following will be query2, query3, etc.

  Returns:
    a String specifying the default query name.

### getNewQueryName

    public java.lang.String getNewQueryName(java.lang.String sourceName)

  Gets a default resource name for the query to be created in the specified data source of the current catalog, which is unique in the specified data source. For example, the first query name is query1, the following will be query2, query3, etc.

  Parameters:
    `sourceName` - The resource name of the data source.
  Returns:
    a String specifying the default query name.

### getNewFormulaName

    public java.lang.String getNewFormulaName()

  Gets a default formula name for the formula to be created in the current catalog,which is unique in the specified data source. For example, the first formula name is formula1, the following will be formula2, formula3, etc.

  Returns:
    a String specifying the default formula name.

### getNewFormulaName

    public java.lang.String getNewFormulaName(java.lang.String sourceName)

  Gets a default mapping name for the formula to be created in the specified data source of the current catalog, which is unique in the specified data source. For example, the first formula name is formula1, the following will be formula2, formula3, etc.

  Parameters:
    `sourceName` - The resource name of the data source.
  Returns:
    a String specifying the default formula name.

### getNewReportName

    public java.lang.String getNewReportName()

  Gets a default report name for the report to be created, which must be unique. The name for the first report will be report1, and the following will be report2, report3....

  Returns:
    a String specifying the new report name.

### getMappingname

    public java.lang.String getMappingname(java.lang.String handle)

  Gets a resource name for the specified catalog object by its handle.

  Parameters:
    `handle` - Indicates the handle of the object, which can identify the object in the catalog.
  Returns:
    a String specifying the object's resource name.

### create

    public Designer create(java.lang.String path,
                           java.lang.String name)

  Deprecated.

  Creates a new Designer with the catalog name.

  Parameters:
    `path` - The catalog file's path.
    `name` - The catalog file's name.
  Returns:
    the newly created Designer object.

### insert

    public java.lang.String insert(java.lang.String name,
                                   int type)

  Adds a resource entity into the catalog. This method adds a blank object with a specified type into the catalog. Generally, the object is an invalid object before it is initialized with its definition information.

  Parameters:
    `name` - Indicates the mapping name of the new object.
    `type` - Indicates the object type of the new object. The `CatalogAPI` class provides a number of convenient constants that you can use to specify the catalog objects. For example,

    >      QUERY
    >      PARAMETER
    >      FORMULA
    >      SUMMARY

  Returns:
    the handle of the new resource entity.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String name,
                                   int type)

  Adds a resource entity into a specified data source in the catalog. This method adds a blank object with a specified type into the catalog. Generally, the object is an invalid object before it is initialized with its definition information.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source. If it is null or "", it means that it is a default data source in the catalog.
    `name` - Indicates the resource name of the new object.
    `type` - Indicates the object type of the new object. The `CatalogAPI` class provides a number of convenient constants that you can use to specify the catalog objects. For example,

    >      DATABASE - The database in the catalog of JReport is also called data dource.
    >      QUERY
    >      PARAMETER
    >      FORMULA
    >      SUMMARY

  Returns:
    handle of the resource entity.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String procName,
                                   java.lang.String catalog,
                                   java.lang.String schema,
                                   java.lang.String name,
                                   java.lang.String remarks,
                                   int iType,
                                   boolean setMappingName)

  Inserts a stored procedure into a Connection of the specified data source. This method adds a JReport stored procedure object which maps the real data source stored procedure into JReport connection. They function like queries, and can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procName` - Indicates the new resource name of the procedure defined in JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search.
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of the procedure type:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
    `setMappingName` - Indicates whether or not to set the mapping name of a field in the procedure as "name_fieldName".
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String procName,
                                   java.lang.String catalog,
                                   java.lang.String schema,
                                   java.lang.String name,
                                   java.lang.String remarks,
                                   int iType,
                                   java.lang.String connector)

  Inserts a stored procedure into a Connection of the specified data source. This method adds a JReport stored procedure object which maps the real database stored procedure into JReport connection. They function like queries, and can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procName` - Indicates the new resource name of the procedure defined in JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined a as 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of the procedure type:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
    `connector` - The character which is used to connect table name and fieldName as the mapping name (resource Name) of a field.
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String procName,
                                   java.lang.String catalog,
                                   java.lang.String schema,
                                   java.lang.String name,
                                   java.lang.String remarks,
                                   int iType,
                                   boolean setMappingName,
                                   java.lang.String connector)

  Inserts a stored procedure into the default Connection of the specified data source. This method adds a JReport stored procedure object which maps the real database stored procedure into JReport connection. They function like queries, and can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `procName` - Indicates the new resource name of the procedure defined in the JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of procedure type:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
    `setMappingName` - Indicates whether or not to set the mapping name of a field in the procedure as "procedureName_fieldName".
    `connector` - The character which is used to connect procedure name and fieldName as the mapping name (resource Name) of the field if setMappingName is true.
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insertStoredProcedure

    public java.lang.String insertStoredProcedure(java.lang.String dataSourceName,
                                                  java.lang.String connectionName,
                                                  java.lang.String procName,
                                                  java.lang.String catalog,
                                                  java.lang.String schema,
                                                  java.lang.String name,
                                                  java.lang.String remarks,
                                                  int iType,
                                                  boolean setMappingName,
                                                  java.lang.String connector)

  Inserts a stored procedure into the specified Connection of the specified data source. This method adds a JReport stored procedure object which maps the real database stored procedure into JReport connection. They function like queries, and can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `connectionName` - Indicates the resource name of connection in the data source.
    `procName` - Indicates the new resource name of the procedure defined in the JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of procedure type:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
    `setMappingName` - Indicates whether or not to set the mapping name of a field in the procedure as "procedureName_fieldName".
    `connector` - The character which is used to connect procedure name and fieldName as the mapping name (resource Name) of the field if setMappingName is true.
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String procName,
                                   java.lang.String catalog,
                                   java.lang.String schema,
                                   java.lang.String name,
                                   java.lang.String remarks,
                                   int iType,
                                   boolean setMappingName)

  Inserts a stored procedure into a Connection of the default data source. This method adds a JReport stored procedure object which maps the real database stored procedure into JReport connection. They function like queries, and can be used as data sources for reports.

  Parameters:
    `procName` - Indicates the new resource name of the procedure defined in JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of the procedure:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
    `setMappingName` - Indicates whether or not to set the mapping name of a field in the procedure as "name_fieldName".
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String procName,
                                   java.lang.String catalog,
                                   java.lang.String schema,
                                   java.lang.String name,
                                   java.lang.String remarks,
                                   int iType)

  Inserts a stored procedure into a Connection of the default data source. This method adds a JReport stored procedure object which maps the real database stored procedure into JReport connection.

  Parameters:
    `procName` - Indicates the new resource name of the procedure defined in the JReport connection.
    `catalog` - Indicates the catalog name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; null means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the procedure of the real database if the procedure is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; null means that the schema name should not be used to narrow the search.
    `name` - Indicates the name of the procedure of the real database.
    `remarks` - Indicates the remark of the procedure.
    `iType` - Indicates the returned result set's type of the procedure. Constants of procedure type:
    - procedureResultUnknown - Cannot determine if a return value will be returned.
    - procedureNoResult - Does not return a return value.
    - procedureReturnsResult - Returns a return value.
    Those definitions of constant values, such as "procedureReturnsResult", can be found in `java.sql.DatabaseMetaData`.
  Returns:
    the handle of the newly inserted procedure. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String strDSName,
                                   java.lang.String strClassName,
                                   java.lang.String strParameter,
                                   UDSColumnInfo udsColInfo)

  Inserts a User Defined Datasource(UDS) into the data source.

  Parameters:
    `strDSName` - Indicates the resource name of new UDS.
    `strClassName` - Indicates the class name of the UDS.
    `strParameter` - Indicates all parameters and their String values. All parameters and values are assembled as parameterName-value pairs. For example, strParameter = "param1=XXX, param2=XXXX".
    `udsColInfo` - Indicates the definition of the UDS's columns.
  Returns:
    the handle of the newly inserted UDS. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String strDSName,
                                   java.lang.String strClassName,
                                   java.lang.String strParameter,
                                   UDSColumnInfo udsColInfo)

  Inserts a User Defined Datasource(UDS) into specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `strDSName` - Indicates the resource name of new UDS.
    `strClassName` - Indicates the class name of the UDS.
    `strParameter` - Indicates all parameters and their String values. All parameters and values are assemble as parametername-value pairs. For example, strParameter = "param1=XXX, param2=XXXX".
    `udsColInfo` - Indicates the definition of UDS's columns.
  Returns:
    the handle of the newly inserted UDS. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String parameterName,
                                   java.lang.String desc,
                                   java.lang.String prompt,
                                   java.lang.String type,
                                   java.lang.String defaultValue)

  Inserts a JReport parameter object into the data source.

  Parameters:
    `parameterName` - Indicates the mapping name of the new parameter.
    `desc` - Indicates a description of the parameter.
    `prompt` - Specifies the prompt text for the new parameter. The prompt text can help user to input a parameter value in runtime.
    `type` - Indicates the parameter's data type. Defined constants for the type:
    - `INTEGER`
    - `NUMBER`
    - `STRING`
    - `CURRENCY`
    - `BOOLEAN`
    - `DATE`
    - `TIME`
    - `DATETIME`
    - `PARAMETERS`
    `defaultValue` - Sets a default value for the parameter. The value and its format must match the parameter's type.
  Returns:
    the handle of the newly inserted parameter. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String parameterName,
                                   java.lang.String desc,
                                   java.lang.String prompt,
                                   java.lang.String type,
                                   java.lang.String defaultValue)

  Inserts a JReport parameter object into the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `parameterName` - Indicates the mapping name of the new parameter.
    `desc` - Indicates a description of the parameter.
    `prompt` - Specifies the prompt text for the new parameter. The prompt text can help user to input parameter value in runtime.
    `type` - Indicates the parameter's data type. Defined constants for the type:
    - `INTEGER`
    - `NUMBER`
    - `STRING`
    - `CURRENCY`
    - `BOOLEAN`
    - `DATE`
    - `TIME`
    - `DATETIME`
    - `PARAMETERS`
    `defaultValue` - Sets a default value for the parameter. The value and its format must match the parameter's type.
  Returns:
    the handle of the newly inserted parameter. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String wherePotionName,
                                   java.lang.String desc,
                                   WherePortionInfo whereportionInfo)

  Inserts a predefined WherePortion into the data source. The where portion stores the SQL where clause.

  Parameters:
    `wherePotionName` - Indicates the resource name of the WherePotion.
    `desc` - Specifies the description of the WherePotion.
    `whereportionInfo` - The WherePortion's information.
  Returns:
    the handle of the newly inserted WherePortion. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String wherePotionName,
                                   java.lang.String desc,
                                   WherePortionInfo whereportionInfo)

  Inserts a predefined WherePortion into the specified data source. The where portion stores the SQL where clause.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `wherePotionName` - Indicates the resource name of the WherePotion.
    `desc` - Specifies the description of the WherePotion.
    `whereportionInfo` - The WherePortion's information.
  Returns:
    the handle of the newly inserted WherePortion. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String formulaName,
                                   java.lang.String desc,
                                   java.lang.String expression)

  Adds a formula into the data source.

  Parameters:
    `formulaName` - Indicates the mapping name of the formula.
    `desc` - Indicates the description of the formula
    `expression` - Indicates the expression and function in String format.
  Returns:
    the handle of the newly inserted formula. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String formulaName,
                                   java.lang.String desc,
                                   java.lang.String expression)

  Adds a formula into the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `formulaName` - Indicates the mapping name of the formula.
    `desc` - Indicates the description of the formula
    `expression` - Indicates the expression and function in String format.
  Returns:
    the handle of the newly inserted formula. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String summaryName,
                                   java.lang.String desc,
                                   int functionType,
                                   java.lang.String fieldName,
                                   java.lang.String groupByFld)

  Adds an aggregate function into the data source. Summaries allow you to generate functions for your data, such as count, average, sum, and standard deviation. Summary functions are based on how you initially grouped the data. For example, if you grouped your data according to country, and you have two groups (US and Canada). Then, if you specify to perform a summary break by country group, you will get the summary result for each group. A summary is a special kind of formula, but it is often used for DBField or an existing formula. Summary functions can also be realized with formula functions.

  Parameters:
    `summaryName` - Indicates the mapping name of the new summary.
    `desc` - Indicates the description of the function.
    `functionType` - Indicates the function type. Defined constants for the function type:
    - `COUNT`
    - `SUM`
    - `AVERAGE`
    - `MAXIMUM`
    - `MINIMUM`
    - `POPULATIONSTDDEV`
    - `POPULATIONVARIANCE`
    - `STDDEV`
    - `VARIANCE`
    - `DISTINCTCOUNT`
    - `RUNNING_COUNT`
    - `RUNNING_SUM`
    - `RUNNING_MAXIMUM`
    - `RUNNING_MINIMUM`
    - `RUNNING_AVERAGE`
    - `RUNNING_DISTINCTCOUNT`
    `fieldName` - Indicates the mapping name of the field that is calculated on.
    `groupByFld` - Indicates the mapping name of the field that is grouped by.
  Returns:
    the handle of the newly inserted function. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String summaryName,
                                   java.lang.String desc,
                                   int functionType,
                                   java.lang.String fieldName,
                                   java.lang.String groupByFld)

  Adds an aggregate function into the data source. Summaries allow you to generate functions for your data, such as count, average, sum, and standard deviation. Summary functions are based on how you initially grouped the data. For example, if you grouped your data according to country, and you have two groups (US and Canada). Then, if you specify to perform a summary break by country group, you will get the summary result for each group. A summary is a special kind of formula, but it is often used for DBField or an existing formula. Summary functions can also be realized with formula functions.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `summaryName` - Indicates the mapping name of the new summary.
    `desc` - Indicates the description of the function.
    `functionType` - Indicates the function type. Defined constants for the function type:
    - `COUNT`
    - `SUM`
    - `AVERAGE`
    - `MAXIMUM`
    - `MINIMUM`
    - `POPULATIONSTDDEV`
    - `POPULATIONVARIANCE`
    - `STDDEV`
    - `VARIANCE`
    - `DISTINCTCOUNT`
    - `RUNNING_COUNT`
    - `RUNNING_SUM`
    - `RUNNING_MAXIMUM`
    - `RUNNING_MINIMUM`
    - `RUNNING_AVERAGE`
    - `RUNNING_DISTINCTCOUNT`
    `fieldName` - Indicates the mapping name of the field that is calculated on.
    `groupByFld` - Indicates the mapping name of the field that is grouped by.
  Returns:
    the handle of the newly inserted function. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String SQLName,
                                   java.lang.String filename)

  Inserts an imported query into the default Connection of the default data source. This method adds a JReport imported query object. Imported queries, which are SQL statements in an external file, can be added to the catalog and also function as queries. They can be used as data sources for reports.

  Parameters:
    `SQLName` - Indicates the resource name of the new imported query.
    `filename` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly inserted imported query. If fails, a `null` value will be returned.

### insertSql

    public java.lang.String insertSql(java.lang.String dataSourceName,
                                      java.lang.String SQLName,
                                      java.lang.String filename)

  Inserts an imported query into a Connection of the specified data source. This method adds a JReport imported query object. Imported queries, which are SQL statements in an external file, can be added to the catalog and also function as queries. They can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `SQLName` - Indicates the resource name of the new imported query.
    `filename` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly inserted imported query. If fails, a `null` value will be returned.

### insertSql

    public java.lang.String insertSql(java.lang.String dataSourceName,
                                      java.lang.String connectionName,
                                      java.lang.String SQLName,
                                      java.lang.String filename)

  Inserts an imported query into the specified Connection of the specified data source. This method adds a JReport imported query object. Imported queries, which are SQL statements in an external file, can be added to the catalog and also function as queries. They can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of the connection in the specified data source in the catalog.
    `SQLName` - Indicates the resource name of the new imported query.
    `filename` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly inserted imported query. If fails, a `null` value will be returned.

### updateSQLFile

    public java.lang.String updateSQLFile(java.lang.String SQLName,
                                          java.lang.String filename)

  Updates an imported query of a Connection of the data source. This method updates the specified imported query object. All the columns of it will be changed according to the SQL statement in the specified file. Imported queries, which are SQL statements in an external file, can be added to the catalog and also function as queries. They can be used as data sources for reports.

  Parameters:
    `SQLName` - Indicates the resource name of the imported query.
    `filename` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly updated imported query. If fails, a `null` value will be returned.

### updateSQLFile

    public java.lang.String updateSQLFile(java.lang.String dataSourceName,
                                          java.lang.String SQLName,
                                          java.lang.String filename)

  Updates an imported query of a Connection of the data source. This method updates the specified imported query object. All the columns of it will be changed according to the SQL statement in the specified file. Imported queries, which are SQL statements in an external file, can be added to the catalog and also function as queries. They can be used as data sources for reports.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `SQLName` - Indicates the resource name of the imported query.
    `filename` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly updated imported query. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(boolean bUseJDBCODBCBridge,
                                   java.lang.String name,
                                   java.lang.String desc,
                                   java.lang.String url,
                                   java.lang.String driver)

  Inserts a JReport database connection object. A database connection defines the database information from which the catalog retrieves its raw data. For example, it specifies the driver such as JDBC driver (for JDBC), or the data source name (for JDBC-ODBC bridge), and the user ID and the password for connecting to the raw data. In this way, a connection is the gateway to the raw database.

  Parameters:
    `bUseJDBCODBCBridge` - Indicates how to connect to the database. if it is `true`, connects by the JDBC_ODBC bridge; otherwise, connects by JDBC driver.
    `name` - Indicates the resource name of the connection.
    `desc` - Indicates a String description for the connection
    `url` - Indicates the URL used to connect to the database if `UseJDBCODBCBridge` is `false`; otherwise, it is the data source name (for JDBC-ODBC bridge).
    `driver` - Indicates the driver class name used to connect to the database if `UseJDBCODBCBridge` is `false`.
  Returns:
    the handle of the newly inserted connection. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   boolean bUseJDBCODBCBridge,
                                   java.lang.String name,
                                   java.lang.String desc,
                                   java.lang.String url,
                                   java.lang.String driver)

  Inserts a JReport database connection object into the database. A database connection defines the database information from which the catalog retrieves its raw data. For example, it specifies the driver such as JDBC driver (for JDBC), or the data source name (for JDBC-ODBC bridge), and the user ID and the password for connecting to the raw data. In this way, a connection is the gateway to the raw database.

  Parameters:
    `bUseJDBCODBCBridge` - Indicates how to connect to the database. if it is `true`, connects by the JDBC_ODBC bridge; otherwise, connects by JDBC driver.
    `name` - Indicates the resource name of the connection.
    `desc` - Indicates a String description for the connection
    `url` - Indicates the URL used to connect to the database if `UseJDBCODBCBridge` is `false`; otherwise, it is the data source name (for JDBC-ODBC bridge).
    `driver` - Indicates the driver class name used to connect to the database if `UseJDBCODBCBridge` is `false`.
  Returns:
    the handle of the newly inserted connection. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(boolean bUseJDBCODBCBridge,
                                   java.lang.String strName,
                                   java.lang.String strDesc,
                                   java.lang.String URL,
                                   java.lang.String driver,
                                   ConnectionInfo info)

  Inserts a JReport database connection object into the specified data source. A database connection defines the database information from which the catalog retrieves its raw data. For example, it specifies the driver such as JDBC driver (for JDBC), or the data source name (for JDBC-ODBC bridge), and the user ID and the password for connecting to the raw data. In this way, a connection is the gateway to the raw database.

  Parameters:
    `bUseJDBCODBCBridge` - Indicates how to connect to the database. if it is `true`, connects by the JDBC_ODBC bridge; otherwise, connects by JDBC driver.
    `strName` - Indicates the resource name of the connection.
    `strDesc` - Indicates a String description for the connection
    `URL` - Indicates the URL used to connect to the database if `UseJDBCODBCBridge` is `false`; otherwise, it is the data source name (for JDBC-ODBC bridge).
    `driver` - Indicates the driver class name used to connect to the database if `UseJDBCODBCBridge` is `false`.
    `info` - Defines the properties of the connection, such as username and password.
  Returns:
    the handle of the newly inserted connection. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   boolean bUseJDBCODBCBridge,
                                   java.lang.String strName,
                                   java.lang.String strDesc,
                                   java.lang.String URL,
                                   java.lang.String driver,
                                   ConnectionInfo info)

  Inserts a JReport database connection object into the specified data source. A database connection defines the database information from which the catalog retrieves its raw data. For example, it specifies the driver such as JDBC driver (for JDBC), or the data source name (for JDBC-ODBC bridge), and the user ID and the password for connecting to the raw data. In this way, a connection is the gateway to the raw database.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `bUseJDBCODBCBridge` - Indicates how to connect to the database. if it is `true`, connects by the JDBC_ODBC bridge; otherwise, connects by JDBC driver.
    `strName` - Indicates the resource name of the connection.
    `strDesc` - Indicates a String description for the connection
    `URL` - Indicates the URL used to connect to the database if `UseJDBCODBCBridge` is `false`; otherwise, it is the data source name (for JDBC-ODBC bridge).
    `driver` - Indicates the driver class name used to connect to the database if `UseJDBCODBCBridge` is `false`.
    `info` - Defines the properties of the connection, such as username and password.
  Returns:
    the handle of the newly inserted connection. If fails, a `null` value will be returned.

### insertWSDLConnection

    public java.lang.String insertWSDLConnection(java.lang.String dataSourceName,
                                                 java.lang.String strName,
                                                 java.lang.String strDesc,
                                                 java.lang.String URI,
                                                 int uriType,
                                                 ConnectionInfo info)

  Inserts a JReport WebService-based connection object into the specified data source. JReport supports web services defined by WSDL 2.0 as data sources. You can add a web service data source to a catalog by importing a WSDL file. A database connection defines the database information from which the catalog retrieves its raw data. For example, it specifies the driver such as JDBC driver (for JDBC), or the data source name (for JDBC-ODBC bridge), and the user ID and the password for connecting to the raw data. In this way, a connection is the gateway to the raw database.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `strName` - Indicates the resource name of the connection.
    `strDesc` - Indicates a String description for the connection
    `URI` - Indicates to use the URI or file location to connect to the WebService.
    `uriType` - Indicates to use a WSDL file on your local disk or through a URI.
    - WSDLTYPE_LOCALEFILE - If you want to use a WSDL file on your local disk.
    - WSDLTYPE_URI - If you want to use a WSDL file through a URI.
    `info` - Defines the properties of the connection, such as username and password.
  Returns:
    the handle of the newly inserted connection. If fails, a `null` value will be returned.

### getConnectionInfo

    public ConnectionInfo getConnectionInfo()

  Gets connection information from the default data source.

  Returns:
    `ConnectionInfo` storing the connection properties

### getConnectionInfo

    public ConnectionInfo getConnectionInfo(java.lang.String dataSourceName)

  Gets connection information from the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    `ConnectionInfo` storing the connection properties

### getConnectionInfo

    public ConnectionInfo getConnectionInfo(java.lang.String dataSourceName,
                                            java.lang.String connectionName)

  Gets connection information from the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of connection in the specified data source. if it is `null`, it means `default` connection.
  Returns:
    `ConnectionInfo` storing the connection properties

### insert

    public java.lang.String insert(java.lang.String catalogName,
                                   java.lang.String schemaPattern,
                                   java.lang.String tablePattern,
                                   int type)

  Inserts a table or view into the data source.

  Parameters:
    `catalog` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as mapping name in JReport database.
    `type` - Indicates the type of table in data source. Constants of the table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String catalogName,
                                   java.lang.String schemaPattern,
                                   java.lang.String tablePattern,
                                   int type,
                                   boolean setMappingName)

  Inserts a table or view into the data source.

  Parameters:
    `catalogName` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as the mapping name in JReport data source.
    `type` - Indicates the type of table in database. Constants of the table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
    `setMappingName` - Indicates whether or not to set the mapping name of the field in the table as "tablePattern_fieldName".
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String tableName,
                                   java.lang.String catalogName,
                                   java.lang.String schemaPattern,
                                   java.lang.String tablePattern,
                                   int type,
                                   boolean setMappingName)

  Inserts a table or view into the data source.

  Parameters:
    `tablename` - Indicates the mapping name of the table.
    `catalogName` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as the mapping name in JReport data source.
    `type` - Indicates the type of table in database. Constants of the table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
    `setMappingName` - Indicates whether or not to set the mapping name of the field in the table as "tablePattern_fieldName".
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String tableName,
                                   java.lang.String catalogName,
                                   java.lang.String schemaPattern,
                                   java.lang.String tablePattern,
                                   int type,
                                   java.lang.String character)

  Inserts a table or view into the data source.

  Parameters:
    `tableName` - Indicates the mapping name of the table.
    `catalogName` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as the mapping name in JReport database.
    `type` - Indicates the type of table in the data source. Constants of table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
    `character` - The character which is used to connect table name and field Name as the mapping name (resource Name) of the field.
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String tableName,
                                   java.lang.String catalogName,
                                   java.lang.String schemaPattern,
                                   java.lang.String tablePattern,
                                   int type,
                                   java.lang.String character)

  Inserts a table or view into the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tableName` - Indicates the mapping name of the table.
    `catalogName` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as the mapping name in JReport data source.
    `type` - Indicates the type of the table in the database. Constants of table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
    `character` - The character which is used to connect table name and field Name as the mapping name (resource Name) of the field.
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### insertTable

    public java.lang.String insertTable(java.lang.String dataSourceName,
                                        java.lang.String connectionName,
                                        java.lang.String tableName,
                                        java.lang.String catalogName,
                                        java.lang.String schemaPattern,
                                        java.lang.String tablePattern,
                                        int type,
                                        java.lang.String character)

  Inserts a table or view into the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of the connection in the specified datasource of the catalog.
    `tableName` - Indicates the mapping name of the table.
    `catalogName` - Indicates the catalog name of the table in the real database. if the table is defined as a 3-part name model; it must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search.
    `schemaPattern` - Indicates the schema name of the table in the real database. if the table is defined as a 3-part name model; it must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search.
    `tablePattern` - Indicates the table name of the table in the real database. And this name is also defined as the mapping name in JReport data source.
    `type` - Indicates the type of the table in the database. Constants of table type:
    - TABLE
    - VIEW
    - SYNONYM
    - ALIAS
    `character` - The character which is used to connect table name and field Name as the mapping name (resource Name) of the field.
  Returns:
    the handle of the newly inserted object. If fails, a `null` value will be returned.

### getPrimaryKeys

    public java.lang.String[] getPrimaryKeys(java.lang.String tablename)

  Gets Primary keys of the table.

  Parameters:
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of Primary keys string.

### getPrimaryKeys

    public java.lang.String[] getPrimaryKeys(java.lang.String dataSourceName,
                                             java.lang.String tablename)

  Gets Primary keys of the table in the default connection of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of Primary keys string.

### getPrimaryKeys

    public java.lang.String[] getPrimaryKeys(java.lang.String dataSourceName,
                                             java.lang.String connectionName,
                                             java.lang.String tablename)

  Gets Primary keys of the table in the specified data source and connection.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of the connection in the specified data source.
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of Primary keys string.

### getForeignKeys

    public java.lang.String[] getForeignKeys(java.lang.String tablename)

  Gets foreign keys of the table.

  Parameters:
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of foreign keys string.

### getForeignKeys

    public java.lang.String[] getForeignKeys(java.lang.String dataSourceName,
                                             java.lang.String tablename)

  Gets foreign keys of the table.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of foreign keys string.

### getForeignKeys

    public java.lang.String[] getForeignKeys(java.lang.String dataSourceName,
                                             java.lang.String connectionName,
                                             java.lang.String tablename)

  Gets foreign keys of the table.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of the connection in the specified data source.
    `tablename` - Indicates the mapping name of the table.
  Returns:
    a list of foreign keys string.

### insertCompCol

    public java.lang.String insertCompCol(java.lang.String qryName,
                                          java.lang.String columnName,
                                          java.lang.String sExpression)

  Inserts a Computed Column into the query. The Computed Column is defined as a formula based on the field in the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
    `sExpression` - Indicates the expression String of this computed column.
  Returns:
    the handle of the newly inserted column. If fails, a `null` value will be returned.

### insertCompCol

    public java.lang.String insertCompCol(java.lang.String dataSourceName,
                                          java.lang.String qryName,
                                          java.lang.String columnName,
                                          java.lang.String sExpression)

  Inserts a Computed Column into the query of the specified data source. The Computed Column is defined as a formula based on the field in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
    `sExpression` - Indicates the expression String of this computed column.
  Returns:
    the handle of the newly inserted column. If fails, a `null` value will be returned.

### deleteCompCol

    public boolean deleteCompCol(java.lang.String qryName,
                                 java.lang.String columnName)

  Deletes the Computed Column from the query. The Computed Column is defined as a formula based on the field in the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
  Returns:
    `true` if the specified Computed Column is removed from query; `false` otherwise.

### deleteCompCol

    public boolean deleteCompCol(java.lang.String dataSourceName,
                                 java.lang.String qryName,
                                 java.lang.String columnName)

  Deletes the Computed Column from the query. The Computed Column is defined as a formula based on the field in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
  Returns:
    `true` if the specified Computed Column is removed from query; `false` otherwise.

### setCompCol

    public boolean setCompCol(java.lang.String qryName,
                              java.lang.String columnName,
                              java.lang.String sExpression)

  Modifies the Computed Column in the query. The new expression will be set to the Computed Column.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
    `sExpression` - Indicates the new expression String of the computed column.
  Returns:
    `true` if the specified Computed Column is changed in query; `false` otherwise.

### setCompCol

    public boolean setCompCol(java.lang.String dataSourceName,
                              java.lang.String qryName,
                              java.lang.String columnName,
                              java.lang.String sExpression)

  Modifies the Computed Column in the query. The new expression will be set to the Computed Column.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
    `sExpression` - Indicates the new expression String of the computed column.
  Returns:
    `true` if the specified Computed Column is changed in query; `false` otherwise.

### insert

    public java.lang.String insert(java.lang.String qryName,
                                   QueryFieldInfo queryFieldInfo,
                                   QueryJoinInfo queryJoinInfo,
                                   QueryQBEInfo queryQBEInfo,
                                   QueryAndInfo queryAndInfo)

  Inserts a query into the catalog.

  Relational databases typically contain many rows of data, with each row constituting a separate record. Most relational database queries retrieve only a portion of the records contained in a table. The WHERE clause qualifies the query command statement to limit the data to specific records from the tables.

  JReport Query's concept is similar to that in the database. The working objects a query can select include tables/views (DBFields), formulas or summaries, and parameters, and the tables/views it can select from are the mapped tables/views defined in a JReport catalog. In this way, a query is independent from the raw database. You can use queries to view, change and analyze data in different ways, and JReport can help you with the building of various professional reports based on queries.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `queryFieldInfo` - Indicates the information of the table and fields in the query.
    `queryJoinInfo` - Indicates the joins information of the query.
    `queryQBEInfo` - Indicates the QBE(Query By Example) information of the query.
    `queryAndInfo` - Indicates the where condition information of the query.
  Returns:
    the handle of the newly inserted query. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String qryName,
                                   QueryFieldInfo queryFieldInfo,
                                   QueryJoinInfo queryJoinInfo,
                                   QueryQBEInfo queryQBEInfo,
                                   QueryAndInfo queryAndInfo)

  Inserts a query into the catalog.

  Relational databases typically contain many rows of data, with each row constituting a separate record. Most relational database queries retrieve only a portion of the records contained in a table. The WHERE clause qualifies the query command statement to limit the data to specific records from the tables.

  JReport Query's concept is similar to that in the database. The working objects a query can select include tables/views (DBFields), formulas or summaries, and parameters, and the tables/views it can select from are the mapped tables/views defined in a JReport catalog. In this way, a query is independent from the raw database. You can use queries to view, change and analyze data in different ways, and JReport can help you with the building of various professional reports based on queries.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `queryFieldInfo` - Indicates the information of the table and fields in the query.
    `queryJoinInfo` - Indicates the joins information of the query.
    `queryQBEInfo` - Indicates the QBE(Query By Example) information of the query.
    `queryAndInfo` - Indicates the where condition information of the query.
  Returns:
    the handle of the newly inserted query. If fails, a `null` value will be returned.

### insertXMLHDS

    public java.lang.String insertXMLHDS(java.lang.String dataSourceName,
                                         java.lang.String name,
                                         java.lang.String xmlPath,
                                         java.lang.String xsdPath)

  Inserts a hierarchical data sources (HDS) into the catalog. JReport supports hierarchical data sources (HDS). This feature uses the hierarchical data source API provided by JReport. In addition, as the XML technology has become a popular standard for data interchange on the web, JReport directly supports XML format data source by wrapping the provided HDS API. JReport's built-in classes can implement the XML format hierarchical data source interface. You can directly import an XML data source to a catalog.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `name` - Indicates the resource name of HDS.
    `xmlPath` - Indicates the full file path of imported XML file.
    `xsdPath` - Indicates the full file path of imported XSD file.
  Returns:
    the handle of the newly inserted HDS. If fails, a `null` value will be returned.
  Since:
    JReport version 8

### insertClassHDS

    public java.lang.String insertClassHDS(java.lang.String dataSourceName,
                                           java.lang.String name,
                                           java.lang.String classPath,
                                           java.lang.String parameter)

  Inserts a hierarchical data sources (HDS) into the catalog. JReport supports hierarchical data sources (HDS). This feature uses the hierarchical data source API provided by JReport. You can develop your own classes to implement the HDS APIs, and then import your customized hierarchical data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `name` - Indicates the resource name of HDS.
    `classPath` - Indicates the full path of the class that implements HDS API.
    `parameter` - Indicates the values of the parameter that can be identified by the implementation class.
  Returns:
    the handle of the newly inserted HDS. If fails, a `null` value will be returned.
  Since:
    JReport version 8

### deleteQuery

    public boolean deleteQuery(java.lang.String qryName)

  Deletes the query from the data source.

  Parameters:
    `qryName` - Indicates the resource name of the query to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteQuery

    public boolean deleteQuery(java.lang.String dataSourceName,
                               java.lang.String qryName)

  Deletes the query from the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String tablename)

  Deletes the specified table in the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteQueryTable

    public boolean deleteQueryTable(java.lang.String dataSourceName,
                                    java.lang.String qryName,
                                    java.lang.String tablename)

  Deletes the specified table in the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String tablename,
                          java.lang.String columnname)

  Deletes the specified table's column in the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
    `columnname` - Indicates the mapping name of the deleted field.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteQueryField

    public boolean deleteQueryField(java.lang.String dataSourceName,
                                    java.lang.String qryName,
                                    java.lang.String tablename,
                                    java.lang.String columnname)

  Deletes the specified table's column in the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
    `columnname` - Indicates the mapping name of the deleted field.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String tableFrom,
                          java.lang.String columnFrom,
                          java.lang.String operator,
                          java.lang.String tableTo,
                          java.lang.String columnTo)

  Deletes a join of the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - The String operator of the join to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          java.lang.String tableFrom,
                          java.lang.String columnFrom,
                          java.lang.String operator,
                          java.lang.String tableTo,
                          java.lang.String columnTo)

  Deletes a join in the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - The operator of the join to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String tablename,
                          java.lang.String columnname,
                          java.lang.String expression)

  Deletes the QBE condition in the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. A certain QBE maybe like: tablen.column (>)= XXX.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `tablename` - The name of the table where the QBE condition is.
    `columnname` - The name of the column where the QBE condition is.
    `expression` - The expression of the QBE condition.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteQBE

    public boolean deleteQBE(java.lang.String dataSourceName,
                             java.lang.String qryName,
                             java.lang.String tablename,
                             java.lang.String columnname,
                             java.lang.String expression)

  Deletes the QBE condition in the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. A certain QBE maybe like: tablen.column (>)= XXX.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `tablename` - The name of the table where the QBE condition is.
    `columnname` - The name of the column where the QBE condition is.
    `expression` - The expression of the QBE condition.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String sExpression1,
                          java.lang.String sOperator,
                          java.lang.String sExpression2,
                          java.lang.String sLogic)

  Deletes where conditions in the query. An example condition could be "sExpression1 sOperator sExpression2 sLogic". If the expression is a field in the query, it must be marked by "@". For example: "@Country = "USA" AND".

  Parameters:
    `qryName` - Indicates the query name in which the where clause stored.
    `sLogic` - The logic string of the where condition to be deleted. The logic describes the relationship between this sentence and the next condition, such as "AND" and "OR".
    `sExpression1` - The first expression of the where condition to be deleted.
    `sOperator` - The operator of the where condition to be deleted.
    `sExpression2` - The second expression of the where condition to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteCondition

    public boolean deleteCondition(java.lang.String dataSourceName,
                                   java.lang.String qryName,
                                   java.lang.String sExpression1,
                                   java.lang.String sOperator,
                                   java.lang.String sExpression2,
                                   java.lang.String sLogic)

  Deletes where conditions in the query. An example condition could be "sExpression1 sOperator sExpression2 sLogic". If the expression is a field in the query, it must be marked by "@". For example: "@Country = "USA" AND".

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `qryName` - Indicates the query name in which the where clause stored.
    `sLogic` - The logic string of the where condition to be deleted. The logic describes the relationship between this sentence and the next condition, such as "AND" and "OR".
    `sExpression1` - The first expression of the where condition to be deleted.
    `sOperator` - The operator of the where condition to be deleted.
    `sExpression2` - The second expression of the where condition to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          UnionInfo info)

  Deletes the "union query" of the query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `info` - Indicates the information of the union query to be deleted. If and only if this definition of the union query matches the existing one in the specified query, the union will be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          UnionInfo info)

  Deletes the "union query" of the query in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `info` - Indicates the information of the union query to be deleted. If and only if this definition of the union query matches the existing one in the specified query, the union will be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String unionQuery,
                          boolean unionAll)

  Deletes the "union query" of the query in the default datasource.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `unionQuery` - Indicates the resource name of the union query to be deleted.
    `unionAll` - Specifies the "unionAll" status of the union query to be deleted. If `true`, all records will be returned; If `false`, no duplicate records will be returned.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### deleteUnionQuery

    public boolean deleteUnionQuery(java.lang.String dataSourceName,
                                    java.lang.String qryName,
                                    java.lang.String unionQuery,
                                    boolean unionAll)

  Deletes the "union query" of the query in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `unionQuery` - Indicates the resource name of the union query to be deleted.
    `unionAll` - Specifies the "unionAll" status of the union query to be deleted. If `true`, all records will be returned; If `false`, no duplicate records will be returned.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### setQueryTable

    public boolean setQueryTable(java.lang.String qryName,
                                 java.lang.String tablename,
                                 boolean selectAllFields)

  Adds a new table into the query of default data source.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted.
    `selectAllFields` - Indicates whether or not to insert the table with all its fields.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setQueryTable

    public boolean setQueryTable(java.lang.String dataSourceName,
                                 java.lang.String qryName,
                                 java.lang.String tablename,
                                 boolean selectAllFields)

  Adds a new table into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted.
    `selectAllFields` - Indicates whether or not to insert the table with all its fields.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setQueryTable

    public boolean setQueryTable(java.lang.String dataSourceName,
                                 java.lang.String qryName,
                                 java.lang.String tablename,
                                 boolean isMapping,
                                 boolean selectAllFields)

  Adds a new table into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted.
    `isMapping` - Indicates whether or not to use table's mapping name to define the query table.
    `selectAllFields` - Indicates whether or not to insert the table with all its fields.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tablename,
                       java.lang.String columnname,
                       boolean isFormula)

  Adds a table's field into the query of the default data source.

  Parameters:
    `tablename` - Indicates the real name of the table to be inserted. If `isFormula` is `true`, this is ignored.
    `columnname` - Indicates the column real name of the table to be inserted. If `isFormula` is `true`, this is mapping name of the formula.
    `isFormula` - Indicates whether or not to insert a formula into the query.
  Returns:
    `true` if inserted successfully; `false` otherwise.
  See Also:
    `setQueryField(String, String, String, String, boolean, boolean)`

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       java.lang.String tablename,
                       java.lang.String columnname,
                       boolean isFormula)

  Adds a new table's field into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted. If `isFormula` is `true`, this is ignored.
    `columnname` - Indicates the column real name of the table to be inserted. If `isFormula` is `true`, this is mapping name of the formula.
    `isFormula` - Indicates whether or not to insert a formula into the query.
  Returns:
    `true` if inserted successfully; `false` otherwise.
  See Also:
    `setQueryField(String, String, String, String, boolean, boolean)`

### setQueryField

    public boolean setQueryField(java.lang.String dataSourceName,
                                 java.lang.String qryName,
                                 java.lang.String tablename,
                                 java.lang.String columnname,
                                 boolean isMapping,
                                 boolean isFormula)

  Adds a new table's field into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted. If `isFormula` is `true`, this is ignored.
    `columnname` - Indicates the column real name of the table to be inserted. If `isFormula` is `true`, this is mapping name of the formula.
    `isMapping` - Indicates whether or not to use table/field's mapping name to define the query field.
    `isFormula` - Indicates whether or not to insert a formula into the query.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       JoinInfo joinInfo)

  Adds a new SQL join into the query of the data source. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `joinInfo` - Defines a join definition to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       JoinInfo joinInfo)

  Adds a new SQL join into the query of the specified data source. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `joinInfo` - Defines a join definition to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tableFrom,
                       java.lang.String columnFrom,
                       java.lang.String operator,
                       java.lang.String tableTo,
                       java.lang.String columnTo)

  Adds a new SQL join into the query of the specified data source. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - Operator of the join to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setJoin

    public boolean setJoin(java.lang.String dataSourceName,
                           java.lang.String qryName,
                           java.lang.String tableFrom,
                           java.lang.String columnFrom,
                           java.lang.String operator,
                           java.lang.String tableTo,
                           java.lang.String columnTo)

  Adds a new SQL join into the query of the specified data source. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source inthe catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - Operator of the join to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setDistinctQuery

    public boolean setDistinctQuery(java.lang.String dataSourceName,
                                    java.lang.String queryName,
                                    boolean isDisTinct)

  set the distinct status of the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query to be changed.
    `isDisTinct` - Indicates whether or not to set "distinct select" status of the query.
  Returns:
    `true` if the parameter is set successfully; otherwise `false`.

### isDistinctQuery

    public boolean isDistinctQuery(java.lang.String dataSourceName,
                                   java.lang.String queryName)

  Geta the distinct status of the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
  Returns:
    `true` if the query is defined as distinct select; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tableFrom,
                       java.lang.String columnFrom,
                       java.lang.String operator,
                       java.lang.String tableTo,
                       java.lang.String columnTo,
                       boolean isSQL92,
                       int outerJoin)

  Adds a new join to the query. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `tableFrom` - Indicates the name of the table from which the join links.
    `columnFrom` - Indicates the name of the column from which the join links.
    `tableTo` - Indicates the name of the table to which the join links.
    `columnTo` - Indicates the name of the column to which the join links.
    `operator` - Indicates the operator of the join to be inserted.
    `isSQL92` - Indicates whether or not to apply SQL92 standard to the join sentence. The property is moved to JDBC connection.
    `outerJoin` - Indicates the type of the outer join. Constants of Join type:
    - `JoinInfo#LEFTOUTER`
    - `JoinInfo#RIGHTOUTER`
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       java.lang.String tableFrom,
                       java.lang.String columnFrom,
                       java.lang.String operator,
                       java.lang.String tableTo,
                       java.lang.String columnTo,
                       boolean isSQL92,
                       int outerJoin)

  Adds a new join to the query. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `tableFrom` - Indicates the name of the table from which the join links.
    `columnFrom` - Indicates the name of the column from which the join links.
    `tableTo` - Indicates the name of the table to which the join links.
    `columnTo` - Indicates the name of the column to which the join links.
    `operator` - Indicates the operator of the join to be inserted.
    `isSQL92` - Indicates whether or not to apply SQL92 standard to the join sentence.
    The property is moved to JDBC connection.
    `outerJoin` - Indicates the type of the outer join. Constants of Join type:
    - `JoinInfo#LEFTOUTER`
    - `JoinInfo#RIGHTOUTER`
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       QBEInfo qbeInfo)

  Adds a QBE condition into the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. A certain QBE maybe like: tablen.column (>)= XXX.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `qbeInfo` - Indicates the QBE information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tablename,
                       java.lang.String columnname,
                       java.lang.String expression)

  Adds a QBE condition into the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. A certain QBE maybe like: tablen.column (>)= XXX.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - The name of the table where the QBE condition will be added.
    `columnname` - The name of the column where the QBE condition will be added.
    `expression` - The expression of the QBE condition.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setQBE

    public boolean setQBE(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          java.lang.String tablename,
                          java.lang.String columnname,
                          java.lang.String expression)

  Adds a QBE condition into the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. A certain QBE maybe like: tablen.column (>)= XXX.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `tablename` - The name of the table where the QBE condition will be added.
    `columnname` - The name of the column where the QBE condition will be added.
    `expression` - The expression of the QBE condition.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### getUnionableQueries

    public java.lang.String[] getUnionableQueries(java.lang.String queryname)

  Gets available query names that can be unioned to this query.

  Parameters:
    `queryname` - Indicates the resource name of the query to be changed.
  Returns:
    a list of all available query names that can be unioned to this query.

### getUnionableQueries

    public java.lang.String[] getUnionableQueries(java.lang.String dataSourceName,
                                                  java.lang.String queryname)

  Gets available query names that can be unioned to this query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryname` - Indicates the resource name of the query to be changed.
  Returns:
    a list of all available query names that can be unioned to this query.

### getUnionInfos

    public UnionInfos getUnionInfos(java.lang.String queryName)

  Gets union query information of a specified query

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    union query information.

### getUnionInfos

    public UnionInfos getUnionInfos(java.lang.String dataSourceName,
                                    java.lang.String queryName)

  Gets union query information of the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    union query information.

### getUnionQueries

    public java.lang.String[] getUnionQueries(java.lang.String queryName)

  Gets unioned query names of the specified query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of union query names.

### getUnionQueries

    public java.lang.String[] getUnionQueries(java.lang.String dataSourceName,
                                              java.lang.String queryName)

  Gets unioned query names of the specified query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of union query names.

### getUnionQueries

    public java.lang.String[] getUnionQueries(java.lang.String queryName,
                                              boolean isUnionAll)

  Gets unioned query names of a specified query according to the union status

  Parameters:
    `queryName` - Indicates the resource name of the query.
    `isUnionAll` - Indicates the union status.
  Returns:
    a list of union query names.

### getUnionQueries

    public java.lang.String[] getUnionQueries(java.lang.String dataSourceName,
                                              java.lang.String queryName,
                                              boolean isUnionAll)

  Gets unioned query names of a specified query according to the union status

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
    `isUnionAll` - Indicates the union status.
  Returns:
    a list of union query names.

### set

    public boolean set(java.lang.String qryName,
                       SubQueryInfo subqueryInfo)

  Adds a subquery into the query. The SQL sentence of the subquery will be merged into the where clause of the main query.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `subqueryInfo` - Indicates subquery's information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       SubQueryInfo subqueryInfo)

  Adds a subquery into the query of the specified data source. The SQL sentence of the subquery will be merged into the where clause of the main query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `subqueryInfo` - The class defines the subquery's information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       UnionInfo unionInfo)

  Adds a union query into the specified query.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `unionInfo` - Union query information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       UnionInfo unionInfo)

  Adds a union query into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `unionInfo` - Union query information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       AndInfo andInfo)

  Adds a new and condition to the query.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `andInfo` - "And" information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       AndInfo andInfo)

  Adds a new and condition to the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `andInfo` - "And" information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String sExpression1,
                       java.lang.String sOperator,
                       java.lang.String sExpression2,
                       java.lang.String sLogic)

  Adds a new where condition into the query. The added sentence will append to the end of the existing whereclause in the query. And the sLogic parameter of this sentence will connect the next available condition; if it is null, it means the end of the query's whereclause.

  Parameters:
    `qryName` - Indicates the resource name of the query to be changed.
    `sLogic` - The logic string of the where condition to be inserted.
    `sExpression1` - The first expression of the where condition to be inserted.
    `sOperator` - The operator of the where condition to be inserted.
    `sExpression2` - The second expression of the where condition to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### setCondition

    public boolean setCondition(java.lang.String dataSourceName,
                                java.lang.String qryName,
                                java.lang.String sExpression1,
                                java.lang.String sOperator,
                                java.lang.String sExpression2,
                                java.lang.String sLogic)

  Adds a new where condition to the specified query. The added sentence will append to the end of the existing whereclause in the query. And the sLogic parameter of this sentence will connect the next available condition; if it is null, it means the end of the query's whereclause.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query to be changed.
    `sLogic` - The logic string of the where condition to be inserted.
    `sExpression1` - The first expression of the where condition to be inserted.
    `sOperator` - The operator of the where condition to be inserted.
    `sExpression2` - The second expression of the where condition to be inserted.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String handle,
                       ParameterInfo info)

  Sets the parameter's information. It changes the definition of the parameter according to the new parameter information.

  Parameters:
    `handle` - Indicates the handle of the parameter. The handle is the unique ID of the object in the catalog.
    `info` - Indicates the new parameter's information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### checkParam

    public boolean checkParam(ParameterInfo info)

  Checks whether or not the parameter's definition is valid.

  Parameters:
    `info` - The definition of the parameter to be checked.
  Returns:
    `true` if the parameter is valid;`false` otherwise.

### getParameterInfo

    public ParameterInfo getParameterInfo(java.lang.String handle)

  Gets the parameter's information. The information is the encapsulated definition of JReport Parameter.

  Parameters:
    `handle` - Indicates the handle of the parameter. The handle is the unique ID of the object in the catalog.
  Returns:
    encapsulated definition of JReport Parameter.

### getSummaryInfo

    public SummaryInfo getSummaryInfo(java.lang.String handle)

  Gets the Summary's information. The information is the encapsulated definition of JReport Summary.

  Parameters:
    `handle` - Indicates the handle of the Summary. The handle is the unique ID of the object in the catalog.
  Returns:
    the encapsulated definition of JReport Summary.

### getFormulaInfo

    public FormulaInfo getFormulaInfo(java.lang.String handle)

  Gets the Formula's information. The information is the encapsulated definition of JReport Formula.

  Parameters:
    `handle` - Indicates the handle of the Formula. The handle is the unique ID of the object in the catalog.
  Returns:
    the encapsulated definition of JReport Formula.

### set

    public boolean set(java.lang.String handle,
                       SummaryInfo info)

  Sets the Summary's information. It changes the definition of the Summary according to the new information.

  Parameters:
    `handle` - Indicates the handle of the Summary. The handle is the unique ID of the object in the catalog.
    `info` - Indicates the new Summary information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### set

    public boolean set(java.lang.String handle,
                       FormulaInfo info)

  Sets the Formula's information. It changes the definition of the Formula according to the new information.

  Parameters:
    `handle` - Indicates the handle of the Formula. The handle is the unique ID of the object in the catalog.
    `info` - Indicates the new formula's information.
  Returns:
    `true` if inserted successfully; `false` otherwise.

### parseFormulae

    public java.lang.String parseFormulae()

  Parses all formulas in the data source. It will recompile all formulas as a java class/method.

  Returns:
    `null` if sccessful, otherwise returns error prompt text.

### parseFormulae

    public java.lang.String parseFormulae(java.lang.String dataSourceName)

  Parses all formulas in the specified data source. It will recompile all formulas as a java class/method.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    `null` if sccessful, otherwise returns error prompt text

### parseFormula

    public java.lang.String parseFormula(FormulaInfo info)

  Parses a formula definition in the data source. It will recompile all formulas as a java class/method.

  Parameters:
    `info` - The encapsulated definition of JReport Formula.
  Returns:
    `null` if successful, otherwise returns error prompt text.

### parseFormula

    public java.lang.String parseFormula(java.lang.String dataSourceName,
                                         FormulaInfo info)

  Parses a formula definition in the data source. It will recompile all formulas as a java class/method.

  Parameters:
    `info` - the encapsulated definition of JReport Formula.
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    `null` if successful, otherwise returns error prompt text.

### isNameExist

    public boolean isNameExist(java.lang.String name)

  Determines whether or not the resource entity exists in the catalog.

  Parameters:
    `name` - Indicates the resource name of the resource entity.
  Returns:
    `true` if the name exists; `false` otherwise.

### isNameExist

    public boolean isNameExist(java.lang.String dataSourceName,
                               java.lang.String name)

  Determines whether or not the resource entity exists in the specified data source of the catalog.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `name` - Indicates the resource name of the resource entity.
  Returns:
    `true` if the name exists; `false` otherwise.

### delete

    public boolean delete(java.lang.String handle)

  Deletes an object from the catalog.

  Specified by:
    `delete` in class `API`
  Parameters:
    `handle` - Indicates the handle of the object to be deleted.
  Returns:
    `true` if deleted successfully; `false` otherwise.

### getDBFields

    public java.lang.String[] getDBFields(java.lang.String qryName)

  Gets DBFields' mapping names that are defined in the query of the specified data source.

  Parameters:
    `qryName` - Indicates the resource name of the query.
  Returns:
    a list of the mapping names of the fields in the query.

### getDBFields

    public java.lang.String[] getDBFields(java.lang.String dataSourceName,
                                          java.lang.String qryName)

  Gets DBFields' mapping names that are defined in the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
  Returns:
    a list of the mapping names of the fields in the query.

### getFormulae

    public java.lang.String[] getFormulae()

  Gets all formulas' mapping names that are defined in the default datasource.

  Returns:
    a list of the mapping names of the formulas in the default data source.

### getFormulae

    public java.lang.String[] getFormulae(java.lang.String dataSourceName)

  Gets all formulas' mapping names that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the mapping names of the formulas in the specified data source.

### getSummaries

    public java.lang.String[] getSummaries()

  Gets all Summaries' mapping names that are defined in the default data source.

  Returns:
    a list of the mapping names of the Summaries in the default data source.

### getSummaries

    public java.lang.String[] getSummaries(java.lang.String dataSourceName)

  Gets all Summaries' mapping names that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the mapping names of the Summaries in the specified data source.

### getSQLs

    public java.lang.String[] getSQLs()

  Gets all Imported SQL queries' resource names that are defined in the default data source.

  Returns:
    a list of the resource names of Imported SQL queries in the data source.

### getSQLs

    public java.lang.String[] getSQLs(java.lang.String dataSourceName)

  Gets all Imported SQL queries' resource names that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the resource names of Imported SQL queries in the data source.

### getSQLColumns

    public java.lang.String[] getSQLColumns(java.lang.String sqlname)

  Gets all columns' real names of the specified Imported SQL query that are defined in the default data source.

  Parameters:
    `sqlname` - Indicates the resource name of the Imported SQL query.
  Returns:
    a list of the names of the column defined in the Imported SQL query.

### getSQLColumns

    public java.lang.String[] getSQLColumns(java.lang.String dataSourceName,
                                            java.lang.String sqlname)

  Gets all columns' real names of the specified Imported SQL query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `sqlname` - Indicates the resource name of the Imported SQL query.
  Returns:
    a list of the names of the columns defined in the Imported SQL query.

### getSQLColumnsMap

    public java.lang.String[] getSQLColumnsMap(java.lang.String sqlname)

  Gets all columns' mapping names of the specified Imported SQL query that are defined in the default data source.

  Parameters:
    `sqlname` - Indicates the resource name of the Imported SQL query.
  Returns:
    a list of the mapping names of the columns defined in the Imported SQL query.

### getSQLColumnsMap

    public java.lang.String[] getSQLColumnsMap(java.lang.String dataSourceName,
                                               java.lang.String sqlname)

  Gets all columns' mapping names of the specified Imported SQL query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `sqlname` - Indicates the resource name of the Imported SQL query.
  Returns:
    a list of the mapping names of the columns defined in the Imported SQL query.

### getUDSs

    public java.lang.String[] getUDSs()

  Gets all resource names of User Data Source(UDS) query that are defined in the specified data source.

  Returns:
    a list of the resource names of UDS defined in the data source.

### getUDSs

    public java.lang.String[] getUDSs(java.lang.String dataSourceName)

  Gets all resource names of User Data Source(UDS) query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the resource names of UDS defined in the data source.

### getHDSs

    public java.lang.String[] getHDSs()

  Gets all resource names of Hierarchical Data Sources (HDS) query that are defined in the default data source.

  Returns:
    a list of the resource names of HDS defined in the data source.

### getHDSs

    public java.lang.String[] getHDSs(java.lang.String dataSourceName)

  Gets all resource names of Hierarchical Data Sources (HDS) query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the resource names of HDS defined in the data source.

### getUDSColumns

    public java.lang.String[] getUDSColumns(java.lang.String udsname)

  Gets all column names of the specified UDS query that are defined in the specified data source.

  Parameters:
    `udsname` - Indicates the resource name of the UDS query.
  Returns:
    a list of the names of the columns defined in the UDS query.

### getUDSColumns

    public java.lang.String[] getUDSColumns(java.lang.String dataSourceName,
                                            java.lang.String udsname)

  Gets all column names of the specified UDS query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `udsname` - Indicates the resource name of the UDS query.
  Returns:
    a list of the names of the columns defined in the UDS query.

### getUDSColumnsMap

    public java.lang.String[] getUDSColumnsMap(java.lang.String udsname)

  Gets all columns' mapping names of the specified UDS query that are defined in the specified data source.

  Parameters:
    `udsname` - Indicates the resource name of the UDS query.
  Returns:
    a list of the mapping names of the columns defined in the UDS query.

### getUDSColumnsMap

    public java.lang.String[] getUDSColumnsMap(java.lang.String dataSourceName,
                                               java.lang.String udsname)

  Gets all columns' mapping names of the specified UDS query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `udsname` - Indicates the resource name of the UDS query.
  Returns:
    a list of the mapping names of the columns defined in the UDS query.

### getProcedureNames

    public java.lang.String[] getProcedureNames()

  Gets all resource names of Stored Procedure query that are defined in the default data source.

  Returns:
    a list of the resource names of Stored Procedure defined in the data source.

### getProcedureNames

    public java.lang.String[] getProcedureNames(java.lang.String dataSourceName)

  Gets all resource names of Stored Procedure query that are defined in the default data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the resource names of Stored Procedure defined in the data source.

### getProcColumns

    public java.lang.String[] getProcColumns(java.lang.String procedureName)

  Gets all column names of the specified Stored Procedure query that are defined in the default data source.

  Parameters:
    `procedureName` - Indicates the resource name of the Stored Procedure query.
  Returns:
    a list of the mapping name of the columns defined in the Stored Procedure query.

### getProcColumns

    public java.lang.String[] getProcColumns(java.lang.String dataSourceName,
                                             java.lang.String procedureName)

  Gets all column names of the specified Stored Procedure query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procedureName` - Indicates the resource name of the Stored Procedure query.
  Returns:
    a list of the names of the columns defined in the Stored Procedure query.

### getProcColumnsMap

    public java.lang.String[] getProcColumnsMap(java.lang.String procedureName)

  Gets all columns' mapping names of the specified Stored Procedure query that are defined in the default data source.

  Parameters:
    `procedureName` - Indicates the resource name of the Stored Procedure query.
  Returns:
    a list of the mapping names of the columns defined in the Stored Procedure query.

### getProcColumnsMap

    public java.lang.String[] getProcColumnsMap(java.lang.String dataSourceName,
                                                java.lang.String procedureName)

  Gets all columns' mapping names of the specified Stored Procedure query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procedureName` - Indicates the resource name of the Stored Procedure query.
  Returns:
    a list of the mapping names of the columns defined in the Stored Procedure query.

### getParameter

    public java.lang.String[] getParameter()

  Gets mapping names of the parameters defined in the default data source.

  Returns:
    a list of the mapping names of the parameters in the data source.

### getParameter

    public java.lang.String[] getParameter(java.lang.String dataSourceName)

  Gets mapping names of the parameters defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
  Returns:
    a list of the resource names of the parameters in the data source.

### getQueries

    public java.lang.String[] getQueries()

  Gets all resource names of the Query that are defined in the default data source.

  Returns:
    a list of the resource names of the Query defined in the data source.

### getQueries

    public java.lang.String[] getQueries(java.lang.String dataSourceName)

  Gets all resource names of the Query that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the resource names of the Query defined in the data source.

### getTables

    public java.lang.String[] getTables()

  Gets all mapping names of the Table/View that are defined in the default data source.

  Returns:
    a list of the mapping names of the Table/View defined in the data source.

### getTables

    public java.lang.String[] getTables(java.lang.String dataSourceName)

  Gets all mapping names of the Table/View that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    a list of the mapping names of the Table/View defined in the data source.

### getTableColumns

    public java.lang.String[] getTableColumns(java.lang.String tablename)

  Gets all columns' real names of the Table/View that are defined in the default data source.

  Parameters:
    `tablename` - Indicates the real name of the table.
  Returns:
    a list of the column names of the Table/View defined in the data source.

### getTableColumns

    public java.lang.String[] getTableColumns(java.lang.String tablename,
                                              boolean isMapping)

  Gets all column names of the Table/View that are defined in the default data source.

  Parameters:
    `tablename` - Indicates the name of the table.
    `isMapping` - Indicates whether or not to use the mapping name to identify the table. If `true`, the table's name is the mapping name; if `false`, it is the real name in the database.
  Returns:
    a list of the column names of the Table/View.

### getTableColumns

    public java.lang.String[] getTableColumns(java.lang.String dataSourceName,
                                              java.lang.String tablename)

  Gets all columns' real names of the Table/View that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tablename` - Indicates the real name of the table.
  Returns:
    a list of the names of the Table/View.

### getTableColumns

    public java.lang.String[] getTableColumns(java.lang.String dataSourceName,
                                              java.lang.String tablename,
                                              boolean isMapping)

  Gets all column names of the Table/View that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tablename` - Indicates the name of the table.
    `isMapping` - Indicates whether or not to use the mapping name to identify the table. If `true`, the table's name is the mapping name; if `false`, it is the real name in the database.
  Returns:
    a list of the names of the Table/View.

### getTableColumnsMap

    public java.lang.String[] getTableColumnsMap(java.lang.String tablename)

  Gets all columns' mapping names of the Table/View that are defined in the default data source.

  Parameters:
    `tablename` - Indicates the real name of the table.
  Returns:
    a list of the mapping names of the Table/View defined in the data source.

### getTableColumnsMap

    public java.lang.String[] getTableColumnsMap(java.lang.String tablename,
                                                 boolean isMapping)

  Gets all columns' mappping names of the Table/View that are defined in the default data source.

  Parameters:
    `tablename` - Indicates the name of the table.
    `isMapping` - Indicates whether or not to use the mapping name to identify the table. If `true`, the table's name is the mapping name; if `false`, it is the real name in the data source.
  Returns:
    a list of the mapping names of the Table/View columns defined in the data source.

### getTableColumnsMap

    public java.lang.String[] getTableColumnsMap(java.lang.String dataSourceName,
                                                 java.lang.String tablename)

  Gets all columns' mapping names of the Table/View that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tablename` - Indicates the name of the table.
  Returns:
    a list of the mapping names of the Table/View defined in the data source.

### getTableColumnsMap

    public java.lang.String[] getTableColumnsMap(java.lang.String dataSourceName,
                                                 java.lang.String tablename,
                                                 boolean isMapping)

  Gets all columns' mapping names of the Table/View that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `tablename` - Indicates the name of the table.
    `isMapping` - Indicates whether or not to use the mapping name to identify the table. If `true`, the table's name is the mapping name; if `false`, it is the real name in the data source.
  Returns:
    a list of the mapping names of the Table/View defined in the data source.

### getSPFields

    public java.lang.String[] getSPFields(java.lang.String dataSourceName,
                                          java.lang.String procedureName,
                                          boolean isMapping)

  Gets field names of the specified stored procedure's fields.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procedureName` - Indicates the name of the Stored Procedure query.
    `isMapping` - Indicates whether or not to use the mapping name to identify the stored procedure. If `true`, the stored procedure's name is the mapping name; if `false`, it is the real name in the database.
  Returns:
    a list of the real names of the stored procedure defined in the database.

### getSPFieldsMap

    public java.lang.String[] getSPFieldsMap(java.lang.String dataSourceName,
                                             java.lang.String procedureName,
                                             boolean isMapping)

  Gets mapping names of the specified stored procedure's fields.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `procedureName` - Indicates the name of the Stored Procedure query.
    `isMapping` - Indicates whether or not to use the mapping name to identify the stored procedure. If `true`, the stored procedure's name is the mapping name; if `false`, it is the real name in the database.
  Returns:
    a list of the mapping names of the fields of the stored procedure.

### getTables

    public java.lang.String[] getTables(boolean bIncludeSystemTable)

  Gets names of tables and views in the database that was defined in the default datasource of catalog. Note: this will access the database with the connection information stored in the datasource's connection.

  Parameters:
    `bIncludeSystemTable` - Indicates whether or not to include the database system tables in the return name list.
  Returns:
    a list of the real names of the table.

### getTables

    public java.lang.String[] getTables(java.lang.String dataSourceName,
                                        boolean bIncludeSystemTable)

  Gets names of tables and views in the database that was defined in the specified datasource of catalog. Note: this will access the database with the connection information stored in datasource's default connection.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `bIncludeSystemTable` - Indicates whether or not to include the database system tables in the return name list.
  Returns:
    a list of the real names of the table.

### getTables

    public java.lang.String[] getTables(java.lang.String dataSourceName,
                                        java.lang.String connectionName,
                                        boolean bIncludeSystemTable)

  Gets names of tables and views in the database that was defined in the specified datasource of catalog. Note: this will access the database with the connection information stored in datasource's specified connection.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `connectionName` - Indicates the resource name of the connection in the specified data source.
    `bIncludeSystemTable` - Indicates whether or not to include the database system tables in the return name list.
  Returns:
    a list of the real names of the table.

### getColumns

    public QueryTableInfo getColumns(java.lang.String queryName,
                                     boolean allColumns)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
    `allColumns` - Indicates where or not to include all columns that are defined in the selected database tables.
  Returns:
    the definitions of the tables and columns in the query.

### getColumns

    public QueryTableInfo getColumns(java.lang.String dataSourceName,
                                     java.lang.String queryName,
                                     boolean allColumns)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
    `allColumns` - Indicates where or not to include all columns that are defined in the selected database tables.
  Returns:
    the definitions of the tables and columns in the query.

### getMapColumns

    public QueryTableInfo getMapColumns(java.lang.String queryName)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the definitions of the tables and columns in the query.

### getMapColumns

    public QueryTableInfo getMapColumns(java.lang.String dataSourceName,
                                        java.lang.String queryName)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the definitions of the tables and columns in the query.

### getCompColumns

    public java.lang.String[] getCompColumns(java.lang.String queryName)

  Gets computed columns in the query

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    computed columns' mapping names defined in the query.

### getCompColumns

    public java.lang.String[] getCompColumns(java.lang.String dataSourceName,
                                             java.lang.String queryName)

  Gets computed columns in the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    computed columns' mapping names defined in the query.

### getCompColumnHandles

    public java.lang.String[] getCompColumnHandles(java.lang.String dataSourceName,
                                                   java.lang.String queryName)

  Gets handles of the computed columns in the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of of the computed column handles.

### getJoins

    public java.lang.String[][] getJoins(java.lang.String queryName)

  Deprecated. Replaced by `getJoinInfos(String queryName)` Gets joins definition in the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of join information. Note: The join information presents as a String[n][7].

    >      String[i][0] = Table "From" Name,
    >      String[i][1] = Column "From" Name,
    >      String[i][2] = Table "To" Name,
    >      String[i][3] = Column "To" Name
    >      String[i][4] = operator
    >      String[i][5] = string value of isSQL92
    >      String[i][6] = string value of outer join type

### getJoins

    public java.lang.String[][] getJoins(java.lang.String dataSourceName,
                                         java.lang.String queryName)

  Deprecated. Replaced by `getJoinInfos(String dataSourceName, String queryName)` Gets joins definition in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of join information. Note: The join information presents as a String[n][7].

    >      String[i][0] = Table "From" Name,
    >      String[i][1] = Column "From" Name,
    >      String[i][2] = Table "To" Name,
    >      String[i][3] = Column "To" Name
    >      String[i][4] = operator
    >      String[i][5] = string value of isSQL92
    >      String[i][6] = string value of outer join type

### getJoinInfos

    public JoinInfo[] getJoinInfos(java.lang.String queryName)

  Gets joins' definitions in the query of default datasource.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the joins' definitions.

### getJoinInfos

    public JoinInfo[] getJoinInfos(java.lang.String dataSourceName,
                                   java.lang.String queryName)

  Gets joins' definitions in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the joins' definitions.

### getQBEInfo

    public java.lang.String[][] getQBEInfo(java.lang.String queryName)

  Deprecated. -Replaced by `getQBEInfos(String queryName)` Gets QBE information in the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of QBE information. Note:The QBE information presents as a String[n][3].

    >      String[i][0] = table Name,
    >      String[i][1] = column Name,
    >      String[i][2] = condition expression of this column.

### getQBEInfo

    public java.lang.String[][] getQBEInfo(java.lang.String dataSourceName,
                                           java.lang.String queryName)

  Deprecated. Replaced by `getQBEInfos(String dataSourceName, String queryName)` Gets QBE information in the query

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of QBE information. Note:The QBE information presents as a String[n][3].

    >      String[i][0] = table Name,
    >      String[i][1] = column Name,
    >      String[i][2] = condition expression of this column.

### getQBEInfos

    public QBEInfo[] getQBEInfos(java.lang.String queryName)

  Gets "QBE" condition information of the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of QBEInfos.

### getQBEInfos

    public QBEInfo[] getQBEInfos(java.lang.String dataSourceName,
                                 java.lang.String queryName)

  Gets "QBE" condition information of the query in the specified data source.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of QBEInfos.

### getSubQueries

    public java.lang.String[] getSubQueries(java.lang.String queryName)

  Gets the "subquery" names of the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of subquery names.

### getSubQueries

    public java.lang.String[] getSubQueries(java.lang.String dataSourceName,
                                            java.lang.String queryName)

  Gets "subquery" names of the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of subquery names.

### getAndConditions

    public java.lang.String[][] getAndConditions(java.lang.String queryName)

  Deprecated. Replaced by `getAndInfos(String queryName)`

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of condition informations. Note:The information presents as a String[n][4].

    >      String[i][0] = "Logic",
    >      String[i][1] =  "Expression1",
    >      String[i][2] = "Operator",
    >      String[i][3] = "Expression2".

### getAndConditions

    public java.lang.String[][] getAndConditions(java.lang.String dataSourceName,
                                                 java.lang.String queryName)

  Deprecated. -Replaced by `getAndInfos(String dataSourceName, String queryName)`

  Parameters:
    `dataSourceName` - Indicates the resource name of data source in catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    a list of condition informations. Note:The information presents as a String[n][4].

    >      String[i][0] = "Logic",
    >      String[i][1] =  "Expression1",
    >      String[i][2] = "Operator",
    >      String[i][3] = "Expression2".

### getAndInfos

    public AndInfo[] getAndInfos(java.lang.String queryName)

  Gets "And" filter condition information of the query

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    AndInfo array

### getAndInfos

    public AndInfo[] getAndInfos(java.lang.String dataSourceName,
                                 java.lang.String queryName)

  Gets "And" filter condition information of the query in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    AndInfos array.

### getColumnMappingnames

    public java.lang.String[] getColumnMappingnames(java.lang.String queryName)

  Gets all columns' mapping names in the query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    array of the columns' mapping names in the query.

### getColumnMappingnames

    public java.lang.String[] getColumnMappingnames(java.lang.String dataSourceName,
                                                    java.lang.String queryName)

  Gets all columns' mapping names in the query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    array of the columns' mapping names in the query.

### getColumnsCanBeGroupedBy

    public QueryTableInfo getColumnsCanBeGroupedBy(java.lang.String queryName)

  Gets columns in the query which can be used to group data in the report. Generally, they are the fields in the query, UDS, Stored Procedure, or Import SQL.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the QueryTableInfo that contains all matching columns.

### getColumnsCanBeGroupedBy

    public QueryTableInfo getColumnsCanBeGroupedBy(java.lang.String dataSourceName,
                                                   java.lang.String queryName)

  Gets columns in the query which can be used to group data in the report. Generally, they are the fields in the query, UDS, Stored Procedure, or Import SQL.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the QueryTableInfo that contains all matching columns.

### getFormulaeForQuery

    public java.lang.String[] getFormulaeForQuery(java.lang.String queryName)

  Gets formulas which are valid to the query. The "valid" means that the formulas and their referred fields are constants or the valid fields in the specified query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the formula names.

### getFormulaeForQuery

    public java.lang.String[] getFormulaeForQuery(java.lang.String dataSourceName,
                                                  java.lang.String queryName)

  Gets formulas which are valid to the query. The "valid" means that the formulas and their referred fields are constants or the valid fields in the specified query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the formula names.

### getSummariesForQuery

    public java.lang.String[] getSummariesForQuery(java.lang.String queryName)

  Gets Summaries which are valid to the query. The "valid" means that the summaries and their referred fields are the valid fields in the specified query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the Summary names.

### getSummariesForQuery

    public java.lang.String[] getSummariesForQuery(java.lang.String dataSourceName,
                                                   java.lang.String queryName)

  Gets Summaries which are valid to the query. The "valid" means that the summaries and their referred fields are the valid fields in the specified query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the Summary names.

### getFormulaeCanBeGroupedBy

    public java.lang.String[] getFormulaeCanBeGroupedBy(java.lang.String queryName)

  Gets formulas which are valid to the query and can be grouped on. The "valid" means that the formulas and their referred fields are the valid fields in the specified query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    the formula names.

### getFormulasCanBeGroupedBy

    public java.lang.String[] getFormulasCanBeGroupedBy(java.lang.String dataSourceName,
                                                        java.lang.String queryName)

  Gets formulas which are valid to the query and can be grouped on The "valid" means that the formulas and their referred fields are the valid fields in the specified query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    the formula names.

### getFormulaeCanBeGroupedBy

    public java.lang.String[] getFormulaeCanBeGroupedBy(java.lang.String queryName,
                                                        java.lang.String groupBy)

  Gets formulas which are valid to the query and can be grouped on this field. The "valid" means that the formulas and their referred fields are the valid fields in the specified query.

  Parameters:
    `queryName` - Indicates the resource name of the query.
    `groupBy` - The groupBy field name.
  Returns:
    the formula names.

### getFormulaeCanBeGroupedBy

    public java.lang.String[] getFormulaeCanBeGroupedBy(java.lang.String dataSourceName,
                                                        java.lang.String queryName,
                                                        java.lang.String groupBy)

  Gets formulas which are valid to the query and can be grouped on this field. The "valid" means that the formulas and their referred fields are the valid fields in the specified query.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
    `groupBy` - The groupBy field name.
  Returns:
    the formula names.

### getChartFunctions

    public java.lang.String[] getChartFunctions(java.lang.String queryName,
                                                java.lang.String groupBy)

  Gets formulas and summaries which are valid to the query and can be grouped on this field.

  Parameters:
    `queryName` - Indicates the resource name of the query.
    `groupBy` - The groupBy field name.
  Returns:
    the formula and summary names.

### getChartFunctions

    public java.lang.String[] getChartFunctions(java.lang.String dataSourceName,
                                                java.lang.String queryName,
                                                java.lang.String groupBy)

  Gets formulas and summaries which are valid to the query and can be grouped on this field.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
    `groupBy` - The groupBy field name.
  Returns:
    the formula and summary names.

### getParameterCanBeGroupedBy

    public java.lang.String[] getParameterCanBeGroupedBy()

  Gets parameters which can be used to group by in the report from the default data source. Only the parameter of String type can be used to group by in the report.

  Returns:
    parameter names array which can be grouped by in the report.

### getParameterCanBeGroupedBy

    public java.lang.String[] getParameterCanBeGroupedBy(java.lang.String dataSourceName)

  Gets parameters which can be used to group by in the report from the specified data source. Only the parameter of String type can be used to group by in the report.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    parameter names array which can be grouped by in the report.

### getSummaryCanBeSortedBy

    public java.lang.String[] getSummaryCanBeSortedBy(java.lang.String queryName,
                                                      java.lang.String groupBy)

  Gets the summaries which can be sorted by in a report group.

  Parameters:
    `queryName` - Indicates the resource name of the query.
    `groupBy` - Indicates the mapping name of the groupBy field.
  Returns:
    summary names array which can be sorted by in a report group.

### getSummaryCanBeSortedBy

    public java.lang.String[] getSummaryCanBeSortedBy(java.lang.String dataSourceName,
                                                      java.lang.String queryName,
                                                      java.lang.String groupBy)

  Gets the summaries which can be sorted by in a report group.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
    `groupBy` - Indicates the mapping name of the groupBy field.
  Returns:
    summary names array which can be sorted by in a report group.

### getMappingnames

    public java.lang.String[] getMappingnames(java.lang.String DSName)

  Gets the fields' mapping names in default data source.

  Parameters:
    `DSName` - The data source object's resource name, such as Query, SQL, UDS, or Procedure.
  Returns:
    the columns' mapping names.

### getMappingnames

    public java.lang.String[] getMappingnames(java.lang.String dataSourceName,
                                              java.lang.String DSName)

  Gets the fields' mapping names in the specified data source

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `DSName` - The data source object's resource name, such as Query, SQL, UDS, or Procedure.
  Returns:
    the columns' mapping names.

### mapFunction

    public java.lang.String mapFunction(int function)

  Converts aggregate function type from number to String.

  Parameters:
    `function` - the int value of function type.
  See Also:
    `COUNT`, `SUM`, `AVERAGE`, `MAXIMUM`, `MINIMUM`, `POPULATIONSTDDEV`, `STDDEV`, `VARIANCE`, `DISTINCTCOUNT`, `RUNNING_COUNT`, `RUNNING_SUM`, `RUNNING_MAXIMUM`, `RUNNING_MINIMUM`, `RUNNING_AVERAGE`, `RUNNING_DISTINCTCOUNT`

### isModified

    public boolean isModified()

  Checks whether or not the catalog has been modified.

  Returns:
    `true` if the catalog has been modified; `false` otherwise.

### setModified

    public void setModified(boolean isModified)

  Sets the modifying status of the Catalog.

  Parameters:
    `isModified` - `true` if the catalog has been modified; `false` otherwise.

### getQuoteChar

    public java.lang.String getQuoteChar()

  Gets the quote char from the default JDBC connection of default data source.

  Returns:
    the String value of the quote char from the JDBC connection.

### getQuoteChar

    public java.lang.String getQuoteChar(java.lang.String dataSourceName)

  Gets the quote char from the JDBC connection of the specified data source

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    the String value of the quote char from the JDBC connection.

### getQuoteChar

    public java.lang.String getQuoteChar(java.lang.String dataSourceName,
                                         java.lang.String connectionName)

  Gets the quote char from the specified JDBC connection.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    the String value of the quote char from the JDBC connection.

### getHandle

    public java.lang.String getHandle(java.lang.String resourceName,
                                      int type)

  Gets the handle of an object according to the object's resource name and object type, which can identify the object in the catalog. resource name is not the unique name of the object in the catalog.

  Parameters:
    `resourceName` - Indicates the resource name of the object in the catalog.
    `type` - indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      BUSINESSLOGIC - The businesslogic of JReport also named Business/Report Cube.
    >      ONDEMAND_QUERY
    >      {@link #XML_CONNECTION

  Returns:
    a String specifying the handle of the object.
  See Also:
    `getHandle(String, String, int)`

### getHandle

    public java.lang.String getHandle(java.lang.String dataSourceName,
                                      java.lang.String resourceName,
                                      int type)

  Gets the handle of an object according to the object's resource name and object type in the specified data source in JReport catalog, which can identify the object in the catalog. resource name is not the unique name of the object in the catalog.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source to get the object's handle. If it is null or "", it means it is the default data source in the catalog.
    `resourceName` - Indicates the resource name of the object in the specified data source.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      BUSINESSLOGIC - The businesslogic of JReport also named Business/Report Cube.
    >      ONDEMAND_QUERY
    >      XML_CONNECTION

  Returns:
    `null` if there is no matching object, otherwise returns a String specifying the handle of the object.

### getFunctions

    public java.lang.String[] getFunctions(java.lang.String resourceName)

  Gets available embedded function names according to the field mapping name. The method gets functions according to the field's SQL type. The field can be the table's column, formula, or parameter.

  Parameters:
    `resourceName` - Indicates field mapping name.
  Returns:
    String array of function names.

### getFunctions

    public java.lang.String[] getFunctions(java.lang.String dataSourceName,
                                           java.lang.String resourceName)

  Gets available embedded function names according to the field mapping name in the specified data source. The method gets functions according to the field's SQL type. The field can be the table's column, formula, or parameter.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is null or "", it means it is the default data source in the catalog.
    `resourceName` - Indicates field resource name.
  Returns:
    String array of function names.

### getFunctions

    public java.lang.String[] getFunctions(int iType)

  Gets available embedded function names according to SQL type.

  Parameters:
    `iType` - Int value of SQL type.
  Returns:
    array of function names.

### rename

    public void rename(java.lang.String resourceName,
                       java.lang.String newName,
                       int type)

  Renames the specified object.

  Parameters:
    `resourceName` - Resource name(mapping name) of the object.
    `newName` - New resource name of the object.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      ONDEMAND_QUERY
    >      XML_CONNECTION

### rename

    public void rename(java.lang.String dataSourceName,
                       java.lang.String resourceName,
                       java.lang.String newName,
                       int type)

  Renames the resource name of the specified object.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `resourceName` - Resource name(mapping name) of the object.
    `newName` - New resource name of the object.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      ONDEMAND_QUERY
    >      XML_CONNECTION

### getObjectInfo

    public ObjectInfo getObjectInfo(java.lang.String resourceName,
                                    int type)

  Gets resource entity's information of an object in catalog. The ObjectInfo defines the object's pairs of properties and values.

  Parameters:
    `resourceName` - resource name of the entity.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      BUSINESSLOGIC - The businesslogic of JReport also named Business/Report Cube.
    >      ONDEMAND_QUERY
    >      XML_CONNECTION

  Returns:
    ObjectInfo object which contains property names and values of the entity.

### getObjectInfo

    public ObjectInfo getObjectInfo(java.lang.String dataSourceName,
                                    java.lang.String resourceName,
                                    int type)

  Gets resource entity's information of an object in the catalog. The ObjectInfo defines the object's pairs of properties and values.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `resourceName` - resource name of the entity.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CONNECTION
    >      TABLE
    >      VIEW
    >      QUERY
    >      PROCEDURE
    >      FILESQL
    >      UDS
    >      FORMULA
    >      SUMMARY
    >      PARAMETER
    >      WHEREPORTION
    >      BUSINESSLOGIC - The businesslogic of JReport also named Business/Report Cube.
    >      ONDEMAND_QUERY
    >      XML_CONNECTION

  Returns:
    ObjectInfo object which contains property names and values of the entity.

### getObjectInfo

    public ObjectInfo getObjectInfo(java.lang.String handle)

  Gets resource entity's information of an object in the catalog. The ObjectInfo defines the object's pairs of properties and values.

  Parameters:
    `handle` - The handle of the resource entity.
  Returns:
    ObjectInfo object which contains property names and values of the entity.

### getSQLType

    public int getSQLType(java.lang.String query,
                          java.lang.String colName)

  Gets sql type of a query column.

  Parameters:
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
  Returns:
    int value of java sql type of the column.

### getSQLType

    public int getSQLType(java.lang.String sourceName,
                          java.lang.String qryName,
                          java.lang.String columnName)

  Gets sql type of a query column.

  Parameters:
    `sourceName` - Indicates the resource name of the data source in the catalog.
    `qryName` - Indicates the resource name of the query.
    `columnName` - Indicates the mapping name of the computed column.
  Returns:
    int value of java sql type of the column.

### getSQLString

    public java.lang.String getSQLString(java.lang.String queryName)

  Gets sql statement text of a queriable object.

  Parameters:
    `queryName` - Indicates the resource name of the query.
  Returns:
    sql statement string.

### getSQLString

    public java.lang.String getSQLString(java.lang.String dataSourceName,
                                         java.lang.String queryName)

  Gets sql statement text of a queriable object.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryName` - Indicates the resource name of the query.
  Returns:
    sql statement string.

### getDataSources

    public java.lang.String[] getDataSources()

  Gets all Data Source names in the catalog.

  Returns:
    the resource name array of the data source.

### getBLNodeQualifyName

    public java.lang.String getBLNodeQualifyName(java.lang.String handle)

  Gets BusinessLogic node's qualified name. Here the BusinessLogic also means the Business/Report Cube and Business View. The qualified name is a unique ID for every JReport BusinessLogic object in BusinessLogic container.

  Parameters:
    `handle` - The handle of the Business Logic object.
  Returns:
    BusinessLogic node's qualified name.
  Since:
    JReport version 8.

### getBLCategoryHandles

    public java.lang.String[] getBLCategoryHandles(java.lang.String handle)

  Gets Business Logic (also named Business/Report Cube) category handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business Logic object.
  Returns:
    handles string array of Category of the Business Logic node.
  Since:
    JReport version 8.

### getBusinesViewCategoryHandles

    public java.lang.String[] getBusinesViewCategoryHandles(java.lang.String handle)

  Gets Business View category handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business View object.
  Returns:
    handles string array of the Business View Category.
  Since:
    JReport version 9.1.

### getBLHierarchyHandles

    public java.lang.String[] getBLHierarchyHandles(java.lang.String handle)

  Gets Business Logic (also named Business/Report Cube) Hierarchy handles in the specified Business Logic node.

  Parameters:
    `handle` - Handle of the Business Logic.
  Returns:
    handles string array of Hierarchy.
  Since:
    JReport version 8.

### getBLDetailHandles

    public java.lang.String[] getBLDetailHandles(java.lang.String handle)

  Gets Business Logic (also named Business/Report Cube) Detail Information handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business Logic object.
  Returns:
    handles string array of the detail information.
  Since:
    JReport version 8.

### getBusinessViewDetailHandles

    public java.lang.String[] getBusinessViewDetailHandles(java.lang.String handle)

  Gets Business View detail handles in the specified Business Logic node.

  Parameters:
    `handle` - Business View node handle.
  Returns:
    handles string array of the Business View detail.
  Since:
    JReport version 8.

### getBLDimensionHandles

    public java.lang.String[] getBLDimensionHandles(java.lang.String handle)

  Gets Business Logic (also named Business/Report Cube) Dimension handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business Logic object.
  Returns:
    handles string array of Dimension.
  Since:
    JReport version 8.

### getBusinessViewGroupHandles

    public java.lang.String[] getBusinessViewGroupHandles(java.lang.String handle)

  Gets Business View Group handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business View object.
  Returns:
    handles string array of the Business View Group.
  Since:
    JReport version 8.

### getBLMeasureHandles

    public java.lang.String[] getBLMeasureHandles(java.lang.String handle)

  Gets Business Logic (also named Business/Report Cube) Measure handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business Logic object.
  Returns:
    handles string array of the Measure.
  Since:
    JReport version 8.

### getBusinessViewAggregationHandles

    public java.lang.String[] getBusinessViewAggregationHandles(java.lang.String handle)

  Gets Business View Aggregation handles in the specified Business Logic node.

  Parameters:
    `handle` - The handle of the Business View object.
  Returns:
    handles string array of the Aggregation.
  Since:
    JReport version 9.1.

### getBLViewHandles

    public java.lang.String[] getBLViewHandles(java.lang.String dataSourceName)

  Gets Business Logic (also named Business/Report Cube) handles in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    handles of the Business Logic entity.
  Since:
    JReport version 8.

### getBusinessViewHandles

    public java.lang.String[] getBusinessViewHandles(java.lang.String dataSourceName)

  Gets Business View handles by the specified query type in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    handles of the Business View entity.
  Since:
    JReport version 9.1.

### getBLViewHandles

    public java.lang.String[] getBLViewHandles(java.lang.String dataSourceName,
                                               int queryType)

  Gets Business Logic (also named Business/Report Cube) handles by the specified query type in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryType` - Indicates the int value of the query type. The query type is:
    - QUERY
    - PROCEDURE
    - FILESQL
    - UDS
  Returns:
    handles of the Business Logic entity.
  Since:
    JReport version 8.

### getBusinessViewHandles

    public java.lang.String[] getBusinessViewHandles(java.lang.String dataSourceName,
                                                     int queryType)

  Gets Business View handles by the specified query type in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryType` - Indicates the int value of the query type. The query type is:
    - QUERY
    - PROCEDURE
    - FILESQL
    - UDS
  Returns:
    handles of the Business View entity.
  Since:
    JReport version 9.1.

### getBLViewNames

    public java.lang.String[] getBLViewNames(java.lang.String dataSourceName)

  Gets Business Logic (also named Business/Report Cube) names in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    name of the Business Logic's entity.
  Since:
    JReport version 8.

### getBusinessViewNames

    public java.lang.String[] getBusinessViewNames(java.lang.String dataSourceName)

  Gets Business View names in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
  Returns:
    name of the Business Views' entity.
  Since:
    JReport version 9.1.

### getBLViewNames

    public java.lang.String[] getBLViewNames(java.lang.String dataSourceName,
                                             int queryType)

  Gets Business Logic (also named Business/Report Cube) names in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryType` - Indicates the int value of the query type. The query type is:
    - QUERY
    - PROCEDURE
    - FILESQL
    - UDS
  Returns:
    name of Business Logic entity.
  Since:
    JReport version 8.

### getBusinessViewNames

    public java.lang.String[] getBusinessViewNames(java.lang.String dataSourceName,
                                                   int queryType)

  Gets Business View names in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queryType` - Indicates the int value of the query type. The query type is:
    - QUERY
    - PROCEDURE
    - FILESQL
    - UDS
  Returns:
    name of Business Views' entity.
  Since:
    JReport version 9.1.

### getBusinessNodeNames

    public java.lang.String[] getBusinessNodeNames(java.lang.String dataSourceName,
                                                   java.lang.String businessViewName)

  Gets business node names of the specified Business Logic (also named Business/Report Cube) in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `businessViewName` - Indicates the Business Logic's qualified name.
  Returns:
    qualified name of the Business Logic nodes.
  Since:
    JReport version 8.

### insertBusinessView

    public java.lang.String insertBusinessView(java.lang.String dataSourceName,
                                               java.lang.String queriableName,
                                               java.lang.String businessViewName)

  Inserts a Business Logic into the specified queriable object. The Business Logic of JReport is also called `Business cube` or `Report cube`.

  A business cube is based on tables and views, while a report cube is based on a query, stored procedure, imported SQL file, or user defined data source. In this method, if `queriableName` is a valid name of an existing queriable object, it will create a report cube; if it is null or does not exist, a business cube will be created automatically.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queriableName` - The queriable object's resource name. The queriable object in JReport catalog could be a Query, UDS, Stored Procedure or Imported SQL.
    `businessViewName` - The new Business Logic name.
  Returns:
    handle of Business Logic.
  Since:
    JReport version 8.

### insertBusinessView

    public java.lang.String insertBusinessView(java.lang.String dataSourceName,
                                               java.lang.String queriableName,
                                               java.lang.String businessViewName,
                                               boolean isLogicView)

  Inserts a Business Logic/View into the specified queriable object. The Business Logic of JReport is also called `Business cube` or `Report cube`.

  A business cube is based on tables and views, while a report cube is based on a query, stored procedure, imported SQL file, or user defined data source. In this method, if `queriableName` is a valid name of existing queriable object, it will create a report cube; if it is null or does not exist, a business cube will be created automatically. Business views are used as data sources for web reports and library components. A Business View provides report users with a business-oriented view of their data and formulas in a query based data source. It contains database connections and relationships between view elements that are required for creating web reports and library components. Business views resemble report cubes except that there is no hierarchical relationship between the data objects in Business Views.

  Parameters:
    `dataSourceName` - Indicates the resource name of the data source in the catalog.
    `queriableName` - Queriable object name.
    `businessViewName` - New Business View name.
    `isLogicView` - Indicates whether to insert a Business Logic or a Business View. If it is `true`, a Business Logic will be created, otherwise, a Business View will be created.
  Returns:
    handle of the created object.
  Since:
    JReport version 9.1.

### insertBLCategory

    public java.lang.String insertBLCategory(java.lang.String parentHandle,
                                             BLCategoryInfo info)
                                      throws DesignerErrorException

  Inserts a Business Logic Category object into the specified container. The BusinessLogic of JReport is also called `Business cube` or `Report cube`.

  Categories are the main tools for organizing data. They are components which correspond to particular collections of data in the data source. They are grouped in folders that are named to reflect information collections. A category can contain several subcategories.

  Organizing data required by a user into multiple categories or multiple levels of categories is meaningful, and makes it easy to use. End users can use categories to find data elements they need to use without knowing the underlying table names although sometimes the table names are used as categories.

  Parameters:
    `parentHandle` - Handle of parent object.
    `info` - The definition class of Category information. The info can contain its children's definition information.
  Returns:
    handle of Business Logic Category.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### insertBusinessViewCategory

    public java.lang.String insertBusinessViewCategory(java.lang.String parentHandle,
                                                       BLCategoryInfo info)
                                                throws DesignerErrorException

  Deprecated. Inserts a Business View Category object into the specified object.

  Categories are the main tools for organizing data. They are components which correspond to particular collections of data in the data source. They are grouped in folders that are named to reflect information collections. A category can contain several subcategories.

  Organizing data required by a user into multiple categories or multiple levels of categories is meaningful, and makes it easy to use. End users can use categories to find data elements they need to use without knowing the underlying table names although sometimes the table names are used as categories.

  Parameters:
    `parentHandle` - Handle of the parent object.
    `info` - The definition class of Category information. The info can contain its children's definition information.
  Returns:
    handle of Business View Category.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.
  See Also:
    `insertBusinessViewCategory(String, BusinessViewCategoryInfo)`

### insertBusinessViewCategory

    public java.lang.String insertBusinessViewCategory(java.lang.String parentHandle,
                                                       BusinessViewCategoryInfo info)
                                                throws DesignerErrorException

  Inserts a Business View Category object into the specified object.

  Categories are the main tools for organizing data. They are components which correspond to particular collections of data in the data source. They are grouped in folders that are named to reflect information collections. A category can contain several subcategories.

  Organizing data required by a user into multiple categories or multiple levels of categories is meaningful, and makes it easy to use. End users can use categories to find data elements they need to use without knowing the underlying table names although sometimes the table names are used as categories.

  Parameters:
    `parentHandle` - The handle of the parent container object. The parent should be a `Category`, or a `Business View` root object.
    `info` - The definition class of Category information. The info can contain its children's definition information.
  Returns:
    handle of Business View Category.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### insertBLDetail

    public java.lang.String insertBLDetail(java.lang.String parentHandle,
                                           BLDetailInfo info)
                                    throws DesignerErrorException

  Inserts a BusinessLogic (also named Business/Report Cube) Detail information object into the specified container object Detail information objects provide additional information. It can be bound to a database field, group object, aggregation object or category/subcategory. Detail objects are used for displaying detailed field values such as address and phone number for a customer in a table or banded object. Detail objects cannot be used in crosstabs and charts.

  Parameters:
    `parentHandle` - The handle of the parent container object. The parent should be a `Category`, `Dimension`, or a `Measure`
    `info` - The definition class of the detail information.
  Returns:
    handle of BusinessLogic Detail.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### insertBusinessViewDetail

    public java.lang.String insertBusinessViewDetail(java.lang.String parentHandle,
                                                     BVDetailInfo info)
                                              throws DesignerErrorException

  Inserts a Business View Detail object into the specified container object. Detail objects provide additional information. It can be bound to a database field, group object, aggregation object or category/subcategory. Detail objects are used for displaying detailed field values such as address and phone number for a customer in a table. Detail objects can not be used in crosstabs and charts.

  Parameters:
    `parentHandle` - The handle of the parent container object. The parent should be a `Category`, `Group`, or a `Aggregation`
    `info` - The definition class of the detail information.
  Returns:
    handle of the Business View detail.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 9.1.

### insertBLMeasure

    public java.lang.String insertBLMeasure(java.lang.String parentHandle,
                                            BLMeasureInfo info)
                                     throws DesignerErrorException

  Inserts a Business Logic (also named Business/Report Cube) Measure objectinto the specified object. Measure objects are numeric cube elements that are calculated dynamically at run time. Measures can be used alone or calculated with other fields. A measure object can be inserted wherever a summary can be inserted. For instance, it can be inserted into the group header or footer panel in a table or banded object, or into a crosstab as an aggregate field. A measure object can also be used as a detail field in a banded object or table although it will display the same aggregate value for every detail line. JReport calculates values based on the group level at which the measure object is inserted such as total sales, average order size and number of orders from a customer.

  Parameters:
    `parentHandle` - Handle of the parent object.
    `info` - The definition class of the measure object.
  Returns:
    handle of the Business Logic measure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### insertBusinessViewAggregation

    public java.lang.String insertBusinessViewAggregation(java.lang.String parentHandle,
                                                          BVAggregationInfo info)
                                                   throws DesignerErrorException

  Inserts a Business View Aggregation object into the specified object. Aggregation objects are numeric view elements that are calculated at run time based on the group objects in the report. Aggregations can be used alone or calculated with other fields. An aggregation object can be inserted wherever summaries can be inserted. For example, aggregations can be inserted in the group header or footer panel of a table, as an aggregate field in a crosstab, or as the value in a chart. JReport calculates values based on the group level at which the aggregation object is inserted such as total sales, average order size and number of orders from a customer.

  Parameters:
    `parentHandle` - Handle of the parent object.
    `info` - The definition class of the Aggregation.
  Returns:
    handle of the Business View Aggregation.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 9.1.

### insertBLDimension

    public java.lang.String insertBLDimension(java.lang.String parentHandle,
                                              BLDimensionInfo info)
                                       throws DesignerErrorException

  Inserts a Business Logic (also named Business/Report Cube) Dimension object into the specified object. Dimension objects are cube elements that are the basis for analysis in a report. They present the availability and key performance of data, and characteristically return text data or dates, and answer the following question: who, when, what, where and which. A dimension object can be inserted wherever a field can be inserted, as a column or row in a crosstab, or as a group field or detail field in a table or banded object or as a category or series in a chart. They may be based on DBFields such as region and country or they could be based on formulas such as the year, quarter, or month portion of a date field.

  Parameters:
    `parentHandle` - Handle of the parent object.
    `info` - The definition class of the Dimension object.
  Returns:
    handle of the Business Logic dimension.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### insertBusinessViewGroup

    public java.lang.String insertBusinessViewGroup(java.lang.String parentHandle,
                                                    BVGroupInfo info)
                                             throws DesignerErrorException

  Inserts a Business View Group object into the specified object. Group objects are view elements that are the basis for organizing data in a report. They present the availability and key performance of data, and characteristically return text data or dates, and answer the following question: who, when, what, where and which. A group object can be inserted wherever a field can be inserted, as a column or row in a crosstab, or as a group field or detail field in a table or as a category or series in a chart. They may be based on DBFields such as region and country or they could be based on formulas such as the year, quarter, or month portion of a date field.

  Parameters:
    `parentHandle` - Handle of the parent object.
    `info` - The definition class of the Group object.
  Returns:
    handle of the Business View Group.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 9.1.

### insertBLHierarchy

    public java.lang.String insertBLHierarchy(java.lang.String blViewHandle,
                                              BLHierarchyInfo info)
                                       throws DesignerErrorException

  Inserts a Business Logic (also named Business/Report Cube) Hierarchy object into the specified object. Hierarchies can be defined in a business/report cube to allow users to drill report data down to particular dimensions in JReport Viewer.

  Parameters:
    `blViewHandle` - Handle of the business logic view.
    `info` - The definition class of the Hierarchy object.
  Returns:
    handle of the Business Logic Hierarchy.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.

### updateUDS

    public boolean updateUDS(java.lang.String userDataSourceName)

  Updates UDS in the default Data Source of the Catalog.

  Parameters:
    `userDataSourceName` - Indicates User Data Source's resource name.
  Returns:
    `true` if the UDS is updated successfully; `false` otherwise.

### updateUDS

    public boolean updateUDS(java.lang.String dataSourceName,
                             java.lang.String userDataSourceName)

  Updates UDS in the specified Data Source of the Catalog.

  Parameters:
    `dataSourceName` - Specifies the Data Source Name.
    `userDataSourceName` - Specifies the User Data Source Name.
  Returns:
    If updated successfully, return true; else returns false.

### refreshReference

    public boolean refreshReference()

  Creates a new or refreshes an existing CrossReference with `CrossReferenceConfigure`.

  Returns:
    `true` if the CrossReference is created or refreshed successfully;`false` otherwise.

### setDefaultDataSource

    public boolean setDefaultDataSource(java.lang.String datasourceName)

  Sets the specified data source as the default data source.

  Parameters:
    `datasourceName` - Indicates the data source's name that will be set as default.
  Returns:
    `true` if the data source is set as default successfully;`false` otherwise.

### setDefaultConnection

    public void setDefaultConnection(java.lang.String datasourceName,
                                     java.lang.String connectionName)

  Sets the specified connection as the `default` in the specified datasource.

  Parameters:
    `datasourceName` - Indicates the datasource's name
    `connectionName` - Indicates the connection's resource name
  Since:
    JReport version 13.1

### getDefaultConnectionName

    public java.lang.String getDefaultConnectionName(java.lang.String datasourceName)

  Gets the resource name of the default connection in the specified data source.

  Parameters:
    `datasourceName` - Indicates the datasource's name
  Returns:
    the default connection name. Return `null` if there is no default connection or causeby the invalid data source name.

### getDefaultDataSourceName

    public java.lang.String getDefaultDataSourceName()

  Gets the data source name of the default data source.

  Returns:
    the default data source name.

### getBLFilterInfos

    public BLFilterInformation[] getBLFilterInfos(java.lang.String handle)

  Gets predefined filter's information of a Business Logic (also named Business/Report Cube/Business View).

  Parameters:
    `handle` - the Business Logic handle.
  Returns:
    `BLFilterInformation`} array

### getBLFilterInfo

    public BLFilterInformation getBLFilterInfo(java.lang.String handle)

  Gets predefined Business Logic (also named Business/Report Cube/Business View) filter information.

  Parameters:
    `handle` - Business Logic predefined filter's handle.
  Returns:
    the `BLFilterInformation` that defines the predefined Business Logic filter

### insertPredefinedBLFilterInfo

    public java.lang.String insertPredefinedBLFilterInfo(java.lang.String blHandle,
                                                         BLFilterInformation filterInfo)
                                                  throws DesignerErrorException

  Adds predefined Business Logic filter into the specified Business Logic (also named Business/Report Cube/Business View) .

  Parameters:
    `blHandle` - the Business Logic handle.
    `filterInfo` - the definition of the Business Logic filter
  Returns:
    the handle of the new Business Logic filter
  Throws:
    `DesignerErrorException`

### getPredifinedFilterHandles

    public java.lang.String[] getPredifinedFilterHandles(java.lang.String handle)

  Gets the predefined Business Logic filters' handle of the specified Business Logic (also named Business/Report Cube/Business View) .

  Parameters:
    `handle` - the Business Logic handle.
  Returns:
    the handles array of the Business Logic filters

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD